#include <windows.h>
#include <stdlib.h>
#include <gl\gl.h>
#include <gl\glu.h>
#include <gl\glaux.h>
#include "glut.h"
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "main.h"
#include "modelo.h"
#include "resource.h"

#include "robot_control.h"

#define PI 3.1415926535897932384626433832795

// variavles externas

extern bool habilitar_panel;
extern bool habilitar_letras;
extern bool configurar_OPEN_GL;
extern bool guardar;
extern bool tipo_panel;
       bool limite=false;

extern bool ver_panel;
extern bool ver_mapa;
extern bool ver_cinematica_vel;
extern bool ver_cinematica_acel;

extern GLuint texture1,texture2;

extern var_robot *variables;
extern float VR;
extern float VL;
extern float V;
extern float W;
extern int initW;

extern float PPX;
extern float PPY;

extern int figura;

extern double dx;
extern double dy;
extern double dz;

extern double col_R;
extern double col_G;
extern double col_B;
extern double col_T;

extern bool mouse;

extern bool borrar;

extern int jugador;

extern int ganador;
double t=0.0;
double data_matrix1[450];
float data_radar[360];


int contador_n=0;

//void inline drawString (char *s,int tipo,float R,float G, float B,float X,float Y)
void drawString (char *s,int tipo,float R,float G, float B,float X,float Y)
{
 unsigned int i;

 if(habilitar_letras){
    glColor3f(R,G,B);
    glRasterPos2f(X,Y);
	    
    if (tipo==10){
       for (i=0; i<strlen(s); i++)
	      glutBitmapCharacter(GLUT_BITMAP_HELVETICA_10, s[i]);}
    else if (tipo==12){
       for (i=0; i<strlen(s); i++)
	      glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, s[i]);}
    else if (tipo==18){
       for (i=0; i<strlen(s); i++)
	      glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18, s[i]);
	}

    //glFlush();
}
}


void OrthoMode(int left, int top, int right, int bottom)
{
	glMatrixMode(GL_PROJECTION);						
	glPushMatrix();									
	glLoadIdentity();								
	glOrtho( left, right, bottom, top, 0, 1 );	
	glMatrixMode(GL_MODELVIEW);								
	glLoadIdentity();										
}

void PerspectiveMode()										 
{
	glMatrixMode( GL_PROJECTION );							
	glPopMatrix();											
	glMatrixMode( GL_MODELVIEW );							
}

GLvoid myglAxes(GLfloat largo, GLfloat ancho)
{
	glLineWidth(ancho);
	glNormal3f(eyex,eyey,-eyez);
	glTranslatef(-1.1*dx,-1.1*dy,-1.1*dz);
	glBegin(GL_LINES);
		glColor3d(1.0,0.0,0.0);
		glVertex3f(largo*0.0f,0.0f,0.0f);
		glVertex3f(largo*1.0f,0.0f,0.0f);

		glVertex3f(largo*0.9f,largo*0.1f,0.0f);
		glVertex3f(largo*1.0f,0.0f,0.0f);

		glVertex3f(largo*0.9f,-largo*0.1f,0.0f);
		glVertex3f(largo*1.0f,largo*0.0f,0.0f);


		glColor3d(0.0,1.0,0.0);
		glVertex3f(0.0f,0.0f,0.0f);
		glVertex3f(0.0f,largo*1.0f,0.0f);

		glVertex3f(0.0f,largo*0.9f,largo*0.1f);
		glVertex3f(0.0f,largo*1.0f,0.0f);

		glVertex3f(0.0f,largo*0.9f,-largo*0.1f);
		glVertex3f(0.0f,largo*1.0f,0.0f);

		glColor3d(0.0,0.0,largo*1.0);
		glVertex3f(0.0f,0.0f,0.0f);
		glVertex3f(0.0f,0.0f,largo*1.0f);

		glVertex3f(largo*0.1f,0.0f,largo*0.9f);
		glVertex3f(0.0f,0.0f,largo*1.0f);

		glVertex3f(-largo*0.1f,0.0f,largo*0.9f);
		glVertex3f(0.0f,0.0f,largo*1.0f);	
	glEnd();

	glTranslatef(1.1*dx,1.1*dy,1.1*dz);
}




void PosMouse()
{
	POINT MousePos;
	int middleX = 320;
	int middleY = 240;

	GetCursorPos(&MousePos);

	if( (MousePos.x == middleX) && (MousePos.y == middleY) ) return;
	
	SetCursorPos(middleX, middleY);	

	theta+=(double)(MousePos.x - middleX)/(double)500;
	phi+=(double)(MousePos.y - middleY)/(double)500;
}

void plot_mapa(float POS_X,float POS_Y,float amp){

float LX_max=variables->X_max;
float LY_max=variables->Y_max;
float L_max;
float L=5.82;
int k_max=0;
int j_max=0;
int j_pos=0;
int j=0;
static char label[100];

if(LX_max>LY_max)
   L_max=LX_max;
else
   L_max=LY_max;

if(L_max<1.0)
  L_max=1.0;
else{

  while(k_max*5.0<L_max)
  k_max++;

  L_max=k_max*5.0; 
  
}


    drawString ("Mapa de Recorrido XY [m]",18,19.0/256.0,46.0/256.0,144.0/256.0,POS_X-3.2,POS_Y+6.0);

    
    for(j=0;j<11;j++){
       sprintf(label,"%2.1f",-L_max+j*L_max/5.0);
	   drawString (label,10,19.0/256.0,46.0/256.0,144.0/256.0,POS_X-6.16+1.18*j,POS_Y-6.19);
       if(j<5)
	   drawString (label,10,19.0/256.0,46.0/256.0,144.0/256.0,POS_X-6.74,POS_Y-5.9+1.16*j);
	   else
	   drawString (label,10,19.0/256.0,46.0/256.0,144.0/256.0,POS_X-6.56,POS_Y-5.9+1.16*j);
	}

    drawString ("GPS NAVCOM",10,19.0/256.0,46.0/256.0,144.0/256.0,-1.79+POS_X+8.29,2.19+POS_Y+2.21);

    drawString ("Latitud",12,19.0/256.0,46.0/256.0,144.0/256.0,-1.79+POS_X+8.29,1.46+POS_Y+2.21);
	sprintf(label,":  %d : %2.2f' %c",variables->ang_lat,variables->min_lat,variables->latitud);
	drawString (label,12,19.0/256.0,46.0/256.0,144.0/256.0,-0.29+POS_X+8.29,1.46+POS_Y+2.21);

	drawString ("Longitud",12,19.0/256.0,46.0/256.0,144.0/256.0,-1.79+POS_X+8.29,1.05+POS_Y+2.21);
	sprintf(label,":  %d : %2.2f' %c",variables->ang_long,variables->min_long,variables->longitud);
    drawString (label,12,19.0/256.0,46.0/256.0,144.0/256.0,-0.29+POS_X+8.29,1.05+POS_Y+2.21);
  
	sprintf(label,"Desp X [m]: %2.2f",variables->desp_X);
    drawString (label,12,19.0/256.0,46.0/256.0,144.0/256.0,-1.79+POS_X+8.29,0.4+POS_Y+2.21);
	sprintf(label,"Desp Y [m]: %2.2f",variables->desp_Y);
    drawString (label,12,19.0/256.0,46.0/256.0,144.0/256.0,-1.79+POS_X+8.29,-0.01+POS_Y+2.21);
	
	drawString ("ODOMETRIA",10,19.0/256.0,46.0/256.0,144.0/256.0,-1.79+POS_X+8.29,-1.05+POS_Y+2.21);
	sprintf(label,"Desp X [m]: %2.2f",variables->pos_X);
    drawString (label,12,19.0/256.0,46.0/256.0,144.0/256.0,-1.79+POS_X+8.29,-1.78+POS_Y+2.21);
	sprintf(label,"Desp Y [m]: %2.2f",variables->pos_Y);
    drawString (label,12,19.0/256.0,46.0/256.0,144.0/256.0,-1.79+POS_X+8.29,-2.19+POS_Y+2.21);
	
	drawString ("X",18,19.0/256.0,46.0/256.0,144.0/256.0,POS_X+9.6,POS_Y-4.6+0.87);
	drawString ("Y",18,19.0/256.0,46.0/256.0,144.0/256.0,POS_X+7.2,POS_Y-2.1+0.87);
	
	sprintf(label,"Rot [grad]: %2.2f",variables->angulo_rot*180/3.14);
    drawString (label,12,1.0,0.0,0.0,-1.79+POS_X+8.29,-2.19+POS_Y+2.21-5.2);

	glPushMatrix();
	glTranslated(POS_X+7.4,POS_Y-4.4+0.87,0);
    glRotated(variables->angulo_rot*180/3.14,0,0,1);
	
	glColor3f(1.0,0.0,0.0);

	glBegin( GL_LINES );
	glVertex2f(0.0,0.0);	
    glVertex2f(0.7,0.0);
	glEnd();	
	
	glBegin( GL_TRIANGLES );
    glVertex2f(0.7,-0.2);
	glVertex2f(0.7,0.2);	
    glVertex2f(1.0,0.0);
	glEnd();

	
	glPopMatrix();

	
	glPushMatrix();
	
	glColor3f(19.0/256.0,46.0/256.0,144.0/256.0);

    glLineWidth(2.0);

	//flechas
	
	glBegin( GL_LINES );
	glVertex2f(POS_X+7.4,POS_Y-4.4+0.87);	
    glVertex2f(POS_X+7.4,1.6+POS_Y-4.4+0.87);
	glEnd();

	glBegin( GL_LINES );
	glVertex2f(POS_X+7.4,POS_Y-4.4+0.87);	
    glVertex2f(1.6+POS_X+7.4,POS_Y-4.4+0.87);
	glEnd();

	glBegin( GL_TRIANGLES );
    glVertex2f(-0.2+POS_X+7.4,POS_Y+1.5-4.4+0.87);
	glVertex2f(0.2+POS_X+7.4,POS_Y+1.5-4.4+0.87);	
    glVertex2f(POS_X+7.4,POS_Y+1.8-4.4+0.87);
	glEnd();

	glBegin( GL_TRIANGLES );
    glVertex2f(1.5+POS_X+7.4,POS_Y-0.2-4.4+0.87);
	glVertex2f(1.5+POS_X+7.4,POS_Y+0.2-4.4+0.87);	
    glVertex2f(1.8+POS_X+7.4,POS_Y-4.4+0.87);
	glEnd();

    //mapa

	glBegin( GL_LINES );
	glVertex2f(L+POS_X,-L+POS_Y);	
    glVertex2f(L+POS_X,L+POS_Y);
	glEnd();

	glBegin( GL_LINES );
	glVertex2f(-L+POS_X,-L+POS_Y);	
    glVertex2f(-L+POS_X,L+POS_Y);
	glEnd();

	glBegin( GL_LINES );
	glVertex2f(-L+POS_X,L+POS_Y);	
    glVertex2f(L+POS_X,L+POS_Y);
	glEnd();

	glBegin( GL_LINES );
	glVertex2f(-L+POS_X,-L+POS_Y);	
    glVertex2f(L+POS_X,-L+POS_Y);
	glEnd();

    glLineWidth(0.5);

    for(j=1;j<10;j++){

	glBegin( GL_LINES );
	glVertex2f(-L+L/5*j+POS_X,-L+POS_Y);	
    glVertex2f(-L+L/5*j+POS_X,L+POS_Y);
	glEnd();

	glBegin( GL_LINES );
	glVertex2f(-L+POS_X,-L+L/5*j+POS_Y);	
    glVertex2f(L+POS_X,-L+L/5*j+POS_Y);
	glEnd();

	}

	glLineWidth(2.0);

    if(variables->vec_j<9999 && limite==false)
	j_max=variables->vec_j;
	else{
	limite=true;
	j_max=9999;
	}

	glColor3f(1.0,0.0,0.0);

	//printf("%d\n",j_max);
    
	j_pos=variables->vec_j-1;
    if(j_pos<0)
	j_pos=0;


    glBegin( GL_QUADS );
	glVertex2f(variables->vec_pos_X[j_pos]*L/L_max+POS_X+0.1,variables->vec_pos_Y[j_pos]*L/L_max+POS_Y);	
	glVertex2f(variables->vec_pos_X[j_pos]*L/L_max+POS_X,variables->vec_pos_Y[j_pos]*L/L_max+POS_Y+0.1);	
	glVertex2f(variables->vec_pos_X[j_pos]*L/L_max+POS_X-0.1,variables->vec_pos_Y[j_pos]*L/L_max+POS_Y);	
	glVertex2f(variables->vec_pos_X[j_pos]*L/L_max+POS_X,variables->vec_pos_Y[j_pos]*L/L_max+POS_Y-0.1);	
	glEnd();

	glColor3f(0.0,0.58,1.0);
	
	glBegin( GL_QUADS );
	glVertex2f(variables->vec_pos_X_UTM[j_pos]*L/L_max+POS_X+0.1,variables->vec_pos_Y_UTM[j_pos]*L/L_max+POS_Y);	
	glVertex2f(variables->vec_pos_X_UTM[j_pos]*L/L_max+POS_X,variables->vec_pos_Y_UTM[j_pos]*L/L_max+POS_Y+0.1);	
	glVertex2f(variables->vec_pos_X_UTM[j_pos]*L/L_max+POS_X-0.1,variables->vec_pos_Y_UTM[j_pos]*L/L_max+POS_Y);	
	glVertex2f(variables->vec_pos_X_UTM[j_pos]*L/L_max+POS_X,variables->vec_pos_Y_UTM[j_pos]*L/L_max+POS_Y-0.1);	
	glEnd();

	for(j=0;j<j_max-1;j++){

	glColor3f(1.0,0.0,0.0);
	
	glBegin( GL_LINES );
	glVertex2f(variables->vec_pos_X[j]*L/L_max+POS_X,variables->vec_pos_Y[j]*L/L_max+POS_Y);	
	glVertex2f(variables->vec_pos_X[j+1]*L/L_max+POS_X,variables->vec_pos_Y[j+1]*L/L_max+POS_Y);	
	glEnd();

	glColor3f(0.0,0.58,1.0);
	
	glBegin( GL_QUADS );
	glVertex2f(variables->vec_pos_X_UTM[j]*L/L_max+POS_X,variables->vec_pos_Y_UTM[j]*L/L_max+POS_Y);	
	glVertex2f(variables->vec_pos_X_UTM[j+1]*L/L_max+POS_X,variables->vec_pos_Y_UTM[j+1]*L/L_max+POS_Y);	
	glEnd();

	}
        
	glColor3f(1.0,1.0,1.0);

	glBegin( GL_QUADS );
	glVertex2f(L+POS_X,L+POS_Y);	
	glVertex2f(L+POS_X,-L+POS_Y);	
	glVertex2f(-L+POS_X,-L+POS_Y);	
    glVertex2f(-L+POS_X,L+POS_Y);
	glEnd();

	glPopMatrix();

}

void plot_cinematica(float POS_X,float POS_Y,float v_max,float *vector,int k_vector){

float marco=0.0;
float guia=0.0;

float LX=7.75;
float LY=2.7;
static char label[100];

    if(v_max<=1) 
    sprintf(label,"%2.2f",v_max);
    else  
    sprintf(label,"%2.0f",v_max);
	drawString (label,10,19.0/256.0,46.0/256.0,144.0/256.0,POS_X-8.6,POS_Y+2.6);

    if(v_max<=1) 
    sprintf(label,"%2.2f",v_max/2.0);
    else  
    sprintf(label,"%2.0f",v_max/2.0);
	drawString (label,10,19.0/256.0,46.0/256.0,144.0/256.0,POS_X-8.6,POS_Y+1.26);

    if(v_max<=1) 
    sprintf(label,"0.00");
    else  
    sprintf(label,"0");
	drawString (label,10,19.0/256.0,46.0/256.0,144.0/256.0,POS_X-8.6,POS_Y-0.14);

    if(v_max<=1) 
    sprintf(label,"%2.2f",-v_max/2.0);
    else  
    sprintf(label,"%2.0f",-v_max/2.0);
	drawString (label,10,19.0/256.0,46.0/256.0,144.0/256.0,POS_X-8.77,POS_Y-1.46);

    if(v_max<=1) 
    sprintf(label,"%2.2f",-v_max);
    else  
    sprintf(label,"%2.0f",-v_max);
	drawString (label,10,19.0/256.0,46.0/256.0,144.0/256.0,POS_X-8.77,POS_Y-2.76);

	glPushMatrix();
		
	glColor3f(19.0/256.0,46.0/256.0,144.0/256.0);

    glLineWidth(0.5);
	
	glBegin( GL_LINES );
	glVertex2f(-LX+POS_X,POS_Y);	
    glVertex2f(LX+POS_X,POS_Y);
	glEnd();

	glBegin( GL_LINES );
	glVertex2f(-LX+POS_X,POS_Y+LY/2);	
    glVertex2f(LX+POS_X,POS_Y+LY/2);
	glEnd();

	glBegin( GL_LINES );
	glVertex2f(-LX+POS_X,POS_Y-LY/2);	
    glVertex2f(LX+POS_X,POS_Y-LY/2);
	glEnd();
	
	glBegin( GL_LINES );
	glVertex2f(POS_X,-LY+POS_Y);	
    glVertex2f(POS_X,LY+POS_Y);
	glEnd();

	glBegin( GL_LINES );
	glVertex2f(-LX/3+POS_X,-LY+POS_Y);	
    glVertex2f(-LX/3+POS_X,LY+POS_Y);
	glEnd();

	glBegin( GL_LINES );
	glVertex2f(-2*LX/3+POS_X,-LY+POS_Y);	
    glVertex2f(-2*LX/3+POS_X,LY+POS_Y);
	glEnd();

	glBegin( GL_LINES );
	glVertex2f(LX/3+POS_X,-LY+POS_Y);	
    glVertex2f(LX/3+POS_X,LY+POS_Y);
	glEnd();

	glBegin( GL_LINES );
	glVertex2f(2*LX/3+POS_X,-LY+POS_Y);	
    glVertex2f(2*LX/3+POS_X,LY+POS_Y);
	glEnd();

    glLineWidth(2);

	glBegin( GL_LINES );
	glVertex2f(-LX+POS_X,-LY+POS_Y);	
    glVertex2f(LX+POS_X,-LY+POS_Y);
	glEnd();

	glBegin( GL_LINES );
    glVertex2f(LX+POS_X,LY+POS_Y);
	glVertex2f(-LX+POS_X,LY+POS_Y);
	glEnd();

	glBegin( GL_LINES );
    glVertex2f(LX+POS_X,LY+POS_Y);
	glVertex2f(LX+POS_X,-LY+POS_Y);
	glEnd();

	glBegin( GL_LINES );
    glVertex2f(-LX+POS_X,LY+POS_Y);
	glVertex2f(-LX+POS_X,-LY+POS_Y);
	glEnd();

	glColor3f( 1.0f, 0.0f, 0.0f );

	
	glBegin( GL_LINES );
	glVertex2f(-LX+((float)k_vector/300.0)*LX+POS_X,-LY+POS_Y);	
    glVertex2f(-LX+((float)k_vector/300.0)*LX+POS_X,LY+POS_Y);	
    glEnd();

	glColor3f( 0.0f, 0.58f, 1.0f );  

	for (int k=0;k<599;k++){
	
	glBegin( GL_LINES );
	glVertex2f(-LX+((float)k/300.0)*LX+POS_X,vector[k]*LY/v_max+POS_Y);	
    glVertex2f(-LX+((float)k/300.0+1.0/300.0)*LX+POS_X,vector[k+1]*LY/v_max+POS_Y);	
    glEnd();
	
	}
	
	glColor3f(1.0,1.0,1.0);

	glBegin( GL_QUADS );
	glVertex2f(LX+POS_X,LY+POS_Y);	
	glVertex2f(LX+POS_X,-LY+POS_Y);	
	glVertex2f(-LX+POS_X,-LY+POS_Y);	
	glVertex2f(-LX+POS_X,LY+POS_Y);	
	glEnd();

	glPopMatrix();
}

void plot_GPS(float POS_X,float POS_Y,float amp){ 
int n=0;
float radio1=1.8; 
float radio2=1.5;
float radio3=0.3;
float radio4=2.5;
float radio5=0.1;
float radio6=0.5;
float radio7=-2.78;
float radio8=0.72;


float largo=0.3;
float ancho=3.6;
int etapas = 24;
static char label[100];

    drawString ("GPS NAVCOM",10,19.0/256,46.0/256,144.0/256,-2.42+POS_X,2.19+POS_Y);

    drawString ("Latitud",12,255.0/256,153.0/256,0.0/256,-1.79+POS_X,1.46+POS_Y);
	sprintf(label,":  %d : %2.2f' %c",variables->ang_lat,variables->min_lat,variables->latitud);
	drawString (label,12,255.0/256,153.0/256,0.0/256,-0.29+POS_X,1.46+POS_Y);

	drawString ("Longitud",12,255.0/256,153.0/256,0.0/256,-1.79+POS_X,1.05+POS_Y);
	sprintf(label,":  %d : %2.2f' %c",variables->ang_long,variables->min_long,variables->longitud);
    drawString (label,12,255.0/256,153.0/256,0.0/256,-0.29+POS_X,1.05+POS_Y);
  
	sprintf(label,"Desp X [m]: %2.2f",variables->desp_X);
    drawString (label,12,255.0/256,153.0/256,0.0/256,-1.79+POS_X,0.4+POS_Y);
	sprintf(label,"Desp Y [m]: %2.2f",variables->desp_Y);
    drawString (label,12,255.0/256,153.0/256,0.0/256,-1.79+POS_X,-0.01+POS_Y);

	
	drawString ("ODOMETRIA",10,19.0/256,46.0/256,144.0/256,-2.42+POS_X,-1.05+POS_Y);
	sprintf(label,"Desp X [m]: %2.2f",variables->pos_X);
    drawString (label,12,255.0/256,153.0/256,0.0/256,-1.79+POS_X,-1.78+POS_Y);
	sprintf(label,"Desp Y [m]: %2.2f",variables->pos_Y);
    drawString (label,12,255.0/256,153.0/256,0.0/256,-1.79+POS_X,-2.19+POS_Y);



	glPushMatrix();

    glColor3f(19.0/256,46.0/256,144.0/256);
	
	glLineWidth(2);
	glBegin( GL_LINES );
	glVertex2f(radio4+POS_X,radio4+POS_Y);
	glVertex2f(radio4+POS_X,-radio6+POS_Y);
	glEnd();
	
	glLineWidth(2);
	glBegin( GL_LINES );
	glVertex2f(-radio4+POS_X,radio4+POS_Y);
	glVertex2f(radio4+POS_X,radio4+POS_Y);
	glEnd();

    glLineWidth(2);
	glBegin( GL_LINES );
	glVertex2f(-radio4+POS_X,-radio6+POS_Y);
	glVertex2f(radio4+POS_X,-radio6+POS_Y);
	glEnd();

    glLineWidth(2);
	glBegin( GL_LINES );
	glVertex2f(-radio4+POS_X,radio4+POS_Y);
	glVertex2f(-radio4+POS_X,-radio6+POS_Y);
	glEnd();

	if(configurar_OPEN_GL){
	glColor3f( 0.375f, 0.375f, 0.375f );
    
	glBegin( GL_QUADS );
	glVertex2f(radio4+POS_X,radio4+POS_Y);
	glVertex2f(radio4+POS_X,-radio6+POS_Y);
	glVertex2f(-radio4+POS_X,-radio6+POS_Y);
	glVertex2f(-radio4+POS_X,radio4+POS_Y);
	glEnd();
    }

    glColor3f(19.0/256,46.0/256,144.0/256);
	
	glLineWidth(2);
	glBegin( GL_LINES );
	glVertex2f(radio4+POS_X,radio7+POS_Y);
	glVertex2f(radio4+POS_X,-radio8+POS_Y);
	glEnd();
	
	glLineWidth(2);
	glBegin( GL_LINES );
	glVertex2f(-radio4+POS_X,radio7+POS_Y);
	glVertex2f(radio4+POS_X,radio7+POS_Y);
	glEnd();

    glLineWidth(2);
	glBegin( GL_LINES );
	glVertex2f(-radio4+POS_X,-radio8+POS_Y);
	glVertex2f(radio4+POS_X,-radio8+POS_Y);
	glEnd();

    glLineWidth(2);
	glBegin( GL_LINES );
	glVertex2f(-radio4+POS_X,radio7+POS_Y);
	glVertex2f(-radio4+POS_X,-radio8+POS_Y);
	glEnd();

	if(configurar_OPEN_GL){
	glColor3f( 0.375f, 0.375f, 0.375f );
    
	glBegin( GL_QUADS );
	glVertex2f(radio4+POS_X,radio7+POS_Y);
	glVertex2f(radio4+POS_X,-radio8+POS_Y);
	glVertex2f(-radio4+POS_X,-radio8+POS_Y);
	glVertex2f(-radio4+POS_X,radio7+POS_Y);
	glEnd();
    }

	glPopMatrix();
   
}

void plot_radar(float *radar, float *cos_angle,float *sin_angle,int particiones,float r_laser,double guia ,float POS_X,float POS_Y,float amp, char *tipo){ 
int n=0; 
float marco=0.00;
static char label[100];

float radio=5;
float radio4=6;
float radio6=1;

    
    drawString ("SICK PLS101",10,19.0/256,46.0/256,144.0/256,-5.92+POS_X,5.7+POS_Y);
    drawString ("0",18,255.0/256,153.0/256,0.0/256,5.31+POS_X,0.0+POS_Y);
	drawString ("45",18,255.0/256,153.0/256,0.0/256,3.54+POS_X,3.73+POS_Y);
	drawString ("90",18,255.0/256,153.0/256,0.0/256,-0.25+POS_X,5.17+POS_Y);
	drawString ("135",18,255.0/256,153.0/256,0.0/256,-4.37+POS_X,3.73+POS_Y);
    drawString ("180",18,255.0/256,153.0/256,0.0/256,-5.95+POS_X,0.0+POS_Y);
 
	sprintf(label,"%2.2f [m]",r_laser/4.0);
    drawString (label,10,255.0/256,153.0/256,0.0/256,0.69+POS_X,-0.52+POS_Y);
 
	sprintf(label,"%2.2f [m]",r_laser/2.0);
    drawString (label,10,255.0/256,153.0/256,0.0/256,-2.88+POS_X,-0.52+POS_Y);

	sprintf(label,"%2.2f [m]",r_laser*3.0/4.0);
    drawString (label,10,255.0/256,153.0/256,0.0/256,3.19+POS_X,-0.52+POS_Y);

	sprintf(label,"%2.2f [m]",r_laser);
    drawString (label,10,255.0/256,153.0/256,0.0/256,-5.38+POS_X,-0.52+POS_Y);
	
	glPushMatrix();

	//glPrint((1.1*radio*amp+POS_X)*100,POS_Y*100,0,"0");/*mensaje tipo grfico*/
    
	glColor3f(19.0/256,46.0/256,144.0/256);
	
	glLineWidth(0.1);
	glBegin( GL_LINES );
	glVertex2f(-radio*amp+POS_X,POS_Y);	
    glVertex2f( radio*amp+POS_X,POS_Y);
	glEnd();
	

	glLineWidth(0.1);
    glBegin( GL_LINES );
	glVertex2f(radio*amp*cos_angle[90]+POS_X,radio*amp*sin_angle[90]+POS_Y);	
    glVertex2f(POS_X,POS_Y);
	glEnd();

    glBegin( GL_LINES );
	glVertex2f(radio*amp*cos_angle[180]+POS_X,radio*amp*sin_angle[180]+POS_Y);	
    glVertex2f(POS_X,POS_Y);
	glEnd();

	glBegin( GL_LINES );
	glVertex2f(radio*amp*cos_angle[270]+POS_X,radio*amp*sin_angle[270]+POS_Y);	
    glVertex2f(POS_X,POS_Y);
	glEnd();


    for(n=0;n<particiones-2;n++){
	   
	   
	   glColor3f(19.0/256,46.0/256,144.0/256);
	   //glColor3f(255.0/256,153.0/256,0.0/256);
	   
	   glLineWidth(0.1);
	   glBegin( GL_LINES );
	   glVertex2f(radio*amp*cos_angle[n]+POS_X,radio*amp*sin_angle[n]+POS_Y);	
	   glVertex2f(radio*amp*cos_angle[n+1]+POS_X,radio*amp*sin_angle[n+1]+POS_Y);	
	   glEnd();

	   glLineWidth(0.1);
	   glBegin( GL_LINES );
	   glVertex2f(radio/4*amp*cos_angle[n]+POS_X,radio/4*amp*sin_angle[n]+POS_Y);	
	   glVertex2f(radio/4*amp*cos_angle[n+1]+POS_X,radio/4*amp*sin_angle[n+1]+POS_Y);	
	   glEnd();

	   glBegin( GL_LINES );
	   glVertex2f(radio/2*amp*cos_angle[n]+POS_X,radio/2*amp*sin_angle[n]+POS_Y);	
	   glVertex2f(radio/2*amp*cos_angle[n+1]+POS_X,radio/2*amp*sin_angle[n+1]+POS_Y);	
	   glEnd();

	   glBegin( GL_LINES );
	   glVertex2f(radio*3/4*amp*cos_angle[n]+POS_X,radio*3/4*amp*sin_angle[n]+POS_Y);	
	   glVertex2f(radio*3/4*amp*cos_angle[n+1]+POS_X,radio*3/4*amp*sin_angle[n+1]+POS_Y);	
	   glEnd();


	   glColor3f(255.0/256,153.0/256,0.0/256);
	
	   if (radar[n]>=0 && radar[n]<r_laser && radar[n+1]>=0 && radar[n+1]<r_laser){
	   glLineWidth(0.1);
	   glBegin( GL_LINES );
	   glVertex2f(radar[n]*radio/r_laser*amp*cos_angle[n]+POS_X,radar[n]*radio/r_laser*amp*sin_angle[n]+POS_Y);	
	   glVertex2f(radar[n+1]*radio/r_laser*amp*cos_angle[n+1]+POS_X,radar[n+1]*radio/r_laser*amp*sin_angle[n+1]+POS_Y);	
	   glEnd();}
	}

	for(n=0;n<particiones-1;n++){

	   glColor3f( 0.0f, 0.0f, 0.0f );
//	   glColor3f(19.0/256,46.0/256,144.0/256);
	   glLineWidth(1);
	 
	   
	   glBegin( GL_TRIANGLES );
	   glVertex2f(radio*amp*cos_angle[n]+POS_X,radio*amp*sin_angle[n]+POS_Y);	
	   glVertex2f(radio*amp*cos_angle[n+1]+POS_X,radio*amp*sin_angle[n+1]+POS_Y);	
	   glVertex2f(POS_X,POS_Y);		   
	   glEnd();
	}
	
    glColor3f(19.0/256,46.0/256,144.0/256);
	
	glLineWidth(2);
	glBegin( GL_LINES );
	glVertex2f(radio4+POS_X,radio4+POS_Y);
	glVertex2f(radio4+POS_X,-radio6+POS_Y);
	glEnd();

	glLineWidth(2);	
	glBegin( GL_LINES );
	glVertex2f(-radio4+POS_X,radio4+POS_Y);
	glVertex2f(radio4+POS_X,radio4+POS_Y);
	glEnd();

	glLineWidth(2);
	glBegin( GL_LINES );
	glVertex2f(-radio4+POS_X,-radio6+POS_Y);
	glVertex2f(radio4+POS_X,-radio6+POS_Y);
	glEnd();

	glLineWidth(2);
	glBegin( GL_LINES );
	glVertex2f(-radio4+POS_X,radio4+POS_Y);
	glVertex2f(-radio4+POS_X,-radio6+POS_Y);
	glEnd();

	if(configurar_OPEN_GL){
	glColor3f( 0.375f, 0.375f, 0.375f );
    
	glBegin( GL_QUADS );
	glVertex2f(radio4+POS_X,radio4+POS_Y);
	glVertex2f(radio4+POS_X,-radio6+POS_Y);
	glVertex2f(-radio4+POS_X,-radio6+POS_Y);
	glVertex2f(-radio4+POS_X,radio4+POS_Y);
	glEnd();
    }

	glPopMatrix();
   // glPrint(500,340,0,"%s",tipo);/*mensaje tipo grfico*/
}


void plot_brujula(float *angulo, float *cos_angle,float *sin_angle,int particiones,float POS_X,float POS_Y,float amp){ 
int n=0;
float radio1=1.85; 
float radio2=1.5;
float radio3=0.3;
float radio4=2.5;
float marco=0.0;
static char label[100];

    drawString ("BRUJULA",10,19.0/256,46.0/256,144.0/256,-2.41+POS_X,2.19+POS_Y);
    drawString ("N",18,255.0/256,153.0/256,0.0/256,-0.15+POS_X,2.0+POS_Y);
    drawString ("S",18,255.0/256,153.0/256,0.0/256,-0.15+POS_X,-2.35+POS_Y);
    drawString ("E",18,255.0/256,153.0/256,0.0/256,2.0+POS_X,-0.12+POS_Y);
    drawString ("O",18,255.0/256,153.0/256,0.0/256,-2.4+POS_X,-0.12+POS_Y);

    drawString ("Angulo",10,255.0/256,153.0/256,0.0/256,-2.36+POS_X,-1.92+POS_Y);
    sprintf(label,"[grad]: %2.2f",*angulo*180/3.14);
	drawString (label,10,255.0/256,153.0/256,0.0/256,-2.36+POS_X,-2.29+POS_Y);
 

	glPushMatrix();
	glTranslated(POS_X,POS_Y,0);

    glRotated(*angulo*180/3.14,0,0,1);

	//glPrint((1.1*radio*amp+POS_X)*100,POS_Y*100,0,"0");/*mensaje tipo grfico*/
        //laser
	
	glColor3f( 0.0f, 0.0f, 0.0f );
	glLineWidth(0.5);
    
	glBegin( GL_LINES );
	glVertex2f(0.25,0.75);	
    glVertex2f(-0.25,0.75);
	glEnd();

    glBegin( GL_LINES );
	glVertex2f(0.25,1.25);	
    glVertex2f(-0.25,1.25);
	glEnd();

	glBegin( GL_LINES );
	glVertex2f(0.25,0.75);	
    glVertex2f(0.25,1.25);
	glEnd();

	glBegin( GL_LINES );
    glVertex2f(-0.25,0.75);
    glVertex2f(-0.25,1.25);	
	glEnd();
	
	glColor3f(194.0/256,204.0/256,11.0/256);
	glBegin( GL_QUADS );
	glVertex2f(0.25,0.75);	
    glVertex2f(-0.25,0.75);
    glVertex2f(-0.25,1.25);
    glVertex2f(0.25,1.25);	
	glEnd();
		
	//cuerpo
	glColor3f( 0.0f, 0.0f, 0.0f );
	glLineWidth(2);
    
	glBegin( GL_LINES );
	glVertex2f(0.5,0.75);	
    glVertex2f(-0.5,0.75);
	glEnd();

    glBegin( GL_LINES );
	glVertex2f(0.5,-0.75);	
    glVertex2f(-0.5,-0.75);
	glEnd();

	glBegin( GL_LINES );
	glVertex2f(0.5,0.75);	
    glVertex2f(0.5,-0.75);
	glEnd();

	glBegin( GL_LINES );
    glVertex2f(-0.5,0.75);
    glVertex2f(-0.5,-0.75);	
	glEnd();
	
	glColor3f(183.0/256,13.0/256,4.0/256);
	
	glBegin( GL_QUADS );
	glVertex2f(0.5,0.75);	
    glVertex2f(-0.5,0.75);
    glVertex2f(-0.5,-0.75);
    glVertex2f(0.5,-0.75);	
	glEnd();

      
	//RUEDAS

	glColor3f( 0.0f, 0.0f, 0.0f );	
	glBegin( GL_QUADS );
	glVertex2f(0.5,0.05);	
    glVertex2f(0.5,0.65);
    glVertex2f(0.8,0.65);
    glVertex2f(0.8,0.05);	
	glEnd();
    
	glBegin( GL_QUADS );
	glVertex2f(-0.5,0.05);	
    glVertex2f(-0.5,0.65);
    glVertex2f(-0.8,0.65);
    glVertex2f(-0.8,0.05);	
	glEnd();

	glBegin( GL_QUADS );
	glVertex2f(0.5,-0.05);	
    glVertex2f(0.5,-0.65);
    glVertex2f(0.8,-0.65);
    glVertex2f(0.8,-0.05);	
	glEnd();

	glBegin( GL_QUADS );
	glVertex2f(-0.5,-0.05);	
    glVertex2f(-0.5,-0.65);
    glVertex2f(-0.8,-0.65);
    glVertex2f(-0.8,-0.05);	
	glEnd();


    for(n=0;n<8;n++){
	   
	   
       glColor3f(255.0/256,153.0/256,0.0/256); 
	   
	   glLineWidth(2);
	   glBegin( GL_LINES );
	   glVertex2f((radio2-radio3/2.0)*amp*cos_angle[n*45],(radio2-radio3/2.0)*amp*sin_angle[n*45]);	
	   glVertex2f((radio2)*amp*cos_angle[n*45],(radio2)*amp*sin_angle[n*45]);	
	   glEnd();

	   glLineWidth(2);
	   glBegin( GL_LINES );
	   glVertex2f(-(radio2-radio3/2.0)*amp*cos_angle[n*45],-(radio2-radio3/2.0)*amp*sin_angle[n*45]);	
	   glVertex2f(-(radio2)*amp*cos_angle[n*45],-(radio2)*amp*sin_angle[n*45]);	
	   glEnd();

	}
	
	/*glRotated(-*angulo*180/3.14,0,0,1);*/
    
     
	glPopMatrix();
	glPushMatrix();

    for(n=0;n<particiones-1;n++){
	   
	   
	   glColor3f(255.0/256,153.0/256,0.0/256); 
	   
	   glLineWidth(0.5);
	   glBegin( GL_LINES );
	   glVertex2f(radio2*amp*cos_angle[n]+POS_X,radio2*amp*sin_angle[n]+POS_Y);	
	   glVertex2f(radio2*amp*cos_angle[n+1]+POS_X,radio2*amp*sin_angle[n+1]+POS_Y);	
	   glEnd();

	   glLineWidth(0.5);
	   glBegin( GL_LINES );
	   glVertex2f(-radio2*amp*cos_angle[n]+POS_X,-radio2*amp*sin_angle[n]+POS_Y);	
	   glVertex2f(-radio2*amp*cos_angle[n+1]+POS_X,-radio2*amp*sin_angle[n+1]+POS_Y);	
	   glEnd();

	   glColor3f(19.0/256,46.0/256,144.0/256);
	   
	   glLineWidth(0.5);
	   glBegin( GL_LINES );
	   glVertex2f(radio1*amp*cos_angle[n]+POS_X,radio1*amp*sin_angle[n]+POS_Y);	
	   glVertex2f(radio1*amp*cos_angle[n+1]+POS_X,radio1*amp*sin_angle[n+1]+POS_Y);	
	   glEnd();

	   glLineWidth(0.5);
	   glBegin( GL_LINES );
	   glVertex2f(-radio1*amp*cos_angle[n]+POS_X,-radio1*amp*sin_angle[n]+POS_Y);	
	   glVertex2f(-radio1*amp*cos_angle[n+1]+POS_X,-radio1*amp*sin_angle[n+1]+POS_Y);	
	   glEnd();

	}

	for(n=0;n<4;n++){
	   
	   glColor3f(19.0/256,46.0/256,144.0/256);
	   
	   glLineWidth(2);
	   glBegin( GL_LINES );
	   glVertex2f((radio1)*amp*cos_angle[n*90]+POS_X,(radio1)*amp*sin_angle[n*90]+POS_Y);	
	   glVertex2f((radio1-radio3/2)*amp*cos_angle[n*90]+POS_X,(radio1-radio3/2)*amp*sin_angle[n*90]+POS_Y);	
	   glEnd();

	   glLineWidth(2);
	   glBegin( GL_LINES );
	   glVertex2f(-(radio1)*amp*cos_angle[n*90]+POS_X,-(radio1)*amp*sin_angle[n*90]+POS_Y);	
	   glVertex2f(-(radio1-radio3/2)*amp*cos_angle[n*90]+POS_X,-(radio1-radio3/2)*amp*sin_angle[n*90]+POS_Y);	
	   glEnd();

	}

    glColor3f(19.0/256,46.0/256,144.0/256);
	
	glBegin( GL_LINES );
	glVertex2f(radio4+POS_X,radio4+POS_Y);
	glVertex2f(radio4+POS_X,-radio4+POS_Y);
	glEnd();

	glBegin( GL_LINES );
	glVertex2f(-radio4+POS_X,radio4+POS_Y);
	glVertex2f(radio4+POS_X,radio4+POS_Y);
	glEnd();

	glBegin( GL_LINES );
	glVertex2f(-radio4+POS_X,-radio4+POS_Y);
	glVertex2f(radio4+POS_X,-radio4+POS_Y);
	glEnd();

	glBegin( GL_LINES );
	glVertex2f(-radio4+POS_X,radio4+POS_Y);
	glVertex2f(-radio4+POS_X,-radio4+POS_Y);
	glEnd();

	if(configurar_OPEN_GL){
	
	glColor3f( 0.375f, 0.375f, 0.375f );
    
	glBegin( GL_QUADS );
	glVertex2f(radio4+POS_X,radio4+POS_Y);
	glVertex2f(radio4+POS_X,-radio4+POS_Y);
	glVertex2f(-radio4+POS_X,-radio4+POS_Y);
	glVertex2f(-radio4+POS_X,radio4+POS_Y);
	glEnd();}

	glPopMatrix();

    //sprintf (label, "%4.1f      %4.5f",angulo, sin(angulo*PI/180));
    
      

   // glPrint(500,340,0,"%s",tipo);/*mensaje tipo grfico*/
}

void plot_velocimetro(float *vel, float vel_max,float *cos_angle,float *sin_angle,int particiones,float POS_X,float POS_Y,float amp, char *tipo){ 
int n=0;
float radio1=1.8; 
float radio2=1.5;
float radio3=0.3;
float radio4=2.5;
float radio5=0.1;
float radio6=1.0;

float largo=0.3;
float ancho=3.6;
int etapas = 24;
static char label[100];

    drawString (tipo,10,19.0/256,46.0/256,144.0/256,-2.41+POS_X,2.19+POS_Y);

    sprintf(label,"Velocidad [cm/s]: %2.2f",*vel);
    drawString (label,10,255.0/256,153.0/256,0.0/256,-1.51+POS_X,-0.86+POS_Y);

    drawString ("0",10,255.0/256,153.0/256,0.0/256,-2.21+POS_X,0.02+POS_Y);
    drawString ("20",10,255.0/256,153.0/256,0.0/256,-2.07+POS_X,0.97+POS_Y);
	drawString ("40",10,255.0/256,153.0/256,0.0/256,-1.24+POS_X,1.78+POS_Y);
	drawString ("60",10,255.0/256,153.0/256,0.0/256,-0.15+POS_X,2.07+POS_Y);
	drawString ("80",10,255.0/256,153.0/256,0.0/256,0.85+POS_X,1.78+POS_Y);
	drawString ("100",10,255.0/256,153.0/256,0.0/256,1.66+POS_X,0.97+POS_Y);
    drawString ("120",10,255.0/256,153.0/256,0.0/256,1.9+POS_X,0.02+POS_Y);
     
	


//float vel_max=120.0;

	glPushMatrix();
	glTranslated(POS_X,POS_Y,0);
    

	if(*vel>=0)
    glRotated(*vel*180/vel_max,0,0,-1);
    else
	glRotated(*vel*180/vel_max,0,0,1);
	//glPrint((1.1*radio*amp+POS_X)*100,POS_Y*100,0,"0");/*mensaje tipo grfico*/
        //laser
		
	glColor3f(255.0/256,153.0/256,0.0/256); 
	glLineWidth(0.5);
	glBegin(GL_QUADS);
	glVertex2f(-radio2*amp,0);
	glVertex2f(0,radio5*amp);	
	glVertex2f(radio5*amp,0);	
	glVertex2f(0,-radio5*amp);	
	glEnd();


	
	/*glRotated(-*angulo*180/3.14,0,0,1);*/
    
     
	glPopMatrix();
	glPushMatrix();

       glColor3f(19.0/256,46.0/256,144.0/256);
	   glLineWidth(2);
	   
	   glBegin(GL_LINES);
	   glVertex2f(POS_X-ancho/2,largo+POS_Y-0.5);
	   glVertex2f(POS_X+ancho/2,largo+POS_Y-0.5);
	   glEnd();

       glBegin(GL_LINES);
	   glVertex2f(POS_X-ancho/2,POS_Y-0.5);
	   glVertex2f(POS_X+ancho/2,POS_Y-0.5);
	   glEnd();

	   glBegin(GL_LINES);
	   glVertex2f(POS_X-ancho/2,POS_Y-0.5);
	   glVertex2f(POS_X-ancho/2,largo+POS_Y-0.5);
	   glEnd();

	   glBegin(GL_LINES);
	   glVertex2f(POS_X+ancho/2,POS_Y-0.5);
	   glVertex2f(POS_X+ancho/2,largo+POS_Y-0.5);
	   glEnd();

    float vel_aux=*vel;
    
	if(vel_aux<0)
	vel_aux=-vel_aux;

    for(n=0;n<(vel_aux/vel_max*etapas-1);n++){
	   	   
	   glColor3f(255.0/256,153.0/256,0.0/256); 
	   glLineWidth(2);
	   glBegin(GL_QUADS);
	   glColor3f(255.0/256,153.0/256,0.0/256);
	   glVertex2f(float(n+1)/etapas*ancho+POS_X-ancho/2,largo+POS_Y-0.5);	
	   glVertex2f(float(n+1)/etapas*ancho+POS_X-ancho/2,POS_Y-0.5);	
	   glColor3f(240.0/256,120.0/256,0.0/256);
	   glVertex2f(float(n)/etapas*ancho+POS_X-ancho/2,POS_Y-0.5);	
	   glVertex2f(float(n)/etapas*ancho+POS_X-ancho/2,largo+POS_Y-0.5);	
	   glEnd();

	}


    for(n=0;n<particiones-1;n++){
	   
	   
	   glColor3f(19.0/256,46.0/256,144.0/256);
	   
	   glLineWidth(2);
	   glBegin( GL_LINES );
	   glVertex2f(radio1*amp*cos_angle[n]+POS_X,radio1*amp*sin_angle[n]+POS_Y);	
	   glVertex2f(radio1*amp*cos_angle[n+1]+POS_X,radio1*amp*sin_angle[n+1]+POS_Y);	
	   glEnd();


	}

	for(n=0;n<7;n++){
	   
	   glColor3f(19.0/256,46.0/256,144.0/256);
	   
	   glLineWidth(2);
	   glBegin( GL_LINES );
	   glVertex2f((radio1)*amp*cos_angle[n*60]+POS_X,(radio1)*amp*sin_angle[n*60]+POS_Y);	
	   glVertex2f((radio1-radio3)*amp*cos_angle[n*60]+POS_X,(radio1-radio3)*amp*sin_angle[n*60]+POS_Y);	
	   glEnd();

	}

    glColor3f(19.0/256,46.0/256,144.0/256);
	
	glBegin( GL_LINES );
	glVertex2f(radio4+POS_X,radio4+POS_Y);
	glVertex2f(radio4+POS_X,-radio6+POS_Y);
	glEnd();

	glBegin( GL_LINES );
	glVertex2f(-radio4+POS_X,radio4+POS_Y);
	glVertex2f(radio4+POS_X,radio4+POS_Y);
	glEnd();

	glBegin( GL_LINES );
	glVertex2f(-radio4+POS_X,-radio6+POS_Y);
	glVertex2f(radio4+POS_X,-radio6+POS_Y);
	glEnd();

	glBegin( GL_LINES );
	glVertex2f(-radio4+POS_X,radio4+POS_Y);
	glVertex2f(-radio4+POS_X,-radio6+POS_Y);
	glEnd();

	if(configurar_OPEN_GL){
	glColor3f( 0.375f, 0.375f, 0.375f );
    
	glBegin( GL_QUADS );
	glVertex2f(radio4+POS_X,radio4+POS_Y);
	glVertex2f(radio4+POS_X,-radio6+POS_Y);
	glVertex2f(-radio4+POS_X,-radio6+POS_Y);
	glVertex2f(-radio4+POS_X,radio4+POS_Y);
	glEnd();
    }

	glPopMatrix();
   
}

void plot_barras(double porcentaje ,float POS_X,float POS_Y,float amp_X,float amp_Y, char *tipo){ 
int n=0; 
float marco=0.00;
/*
float POS_X=-5.;
float POS_Y=0;
float amp_X=1.5;
float amp_Y=1.5;
*/
	glPushMatrix();

	glColor3f( 0.0f, 1.0f, 0.0f );

	glBegin( GL_LINES );
	glVertex2f((0-marco)*amp_X+POS_X,(0-marco)*amp_Y+POS_Y);	
    glVertex2f((1+marco)*amp_X+POS_X,(0-marco)*amp_Y+POS_Y);
	glEnd();

	glBegin( GL_LINES );
    glVertex2f((1+marco)*amp_X+POS_X,(1+marco)*amp_Y+POS_Y);
	glVertex2f((0-marco)*amp_X+POS_X,(1+marco)*amp_Y+POS_Y);
	glEnd();

	glBegin( GL_LINES );
    glVertex2f((1+marco)*amp_X+POS_X,(1+marco)*amp_Y+POS_Y);
	glVertex2f((1+marco)*amp_X+POS_X,(0-marco)*amp_Y+POS_Y);
	glEnd();

	glBegin( GL_LINES );
    glVertex2f((0-marco)*amp_X+POS_X,(1+marco)*amp_Y+POS_Y);
	glVertex2f((0-marco)*amp_X+POS_X,(0-marco)*amp_Y+POS_Y);
	glEnd();

    glBegin(GL_QUADS);
    glColor3f( porcentaje, 1.0f,porcentaje ); 
    glVertex2f((1+marco)*amp_X+POS_X,(porcentaje+marco)*amp_Y+POS_Y);
	glVertex2f((0-marco)*amp_X+POS_X,(porcentaje+marco)*amp_Y+POS_Y);
	glColor3f( 0.0f,1.0f, 0.0f ); 
	glVertex2f((0-marco)*amp_X+POS_X,(0-marco)*amp_Y+POS_Y);
	glVertex2f((1+marco)*amp_X+POS_X,(0-marco)*amp_Y+POS_Y);

    glEnd();
	 
	
	glPopMatrix();
   // glPrint(500,340,0,"%s",tipo);/*mensaje tipo grfico*/
}


void DrawGLScene(float *cos_angle,float *sin_angle)
{
double auxiliar;
	
if(mouse==true)
		PosMouse();

#ifdef CENTRO
	centerx = -eyed*sin(phi)*cos(theta);
	centery = eyed*sin(phi)*sin(theta);
	centerz = -eyed*cos(phi);
#else
	eyex = eyed*sin(phi)*cos(theta);
	eyey = eyed*sin(phi)*sin(theta);
	eyez = eyed*cos(phi);
#endif
	
	/* Correccion de la normal cuando phi = 0 o Pi*/
	if(sin(phi)>0.0) 
	{
		upz=1.0;
	}
	else if(sin(phi)<0.0) 
	{
		upz=-1.0f;
	}

	//color de fondo
	
	if(configurar_OPEN_GL)
	glClearColor(0.831f,0.816f,0.784f,0.0f);
    else
	glClearColor(0.525f,0.525f,0.525f,0.0f);

	if(ver_mapa || ver_cinematica_vel || ver_cinematica_acel)
	glClearColor(0.831f,0.816f,0.784f,0.0f);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glLoadIdentity();

	gluLookAt(0.0,0.0,16.0,0.0,0.0,-1.0,0.0,1.0,0.0);
	 
	if(habilitar_panel && ver_panel){

    glPrintf(10000,10000,0,"120");
	plot_radar(variables->r_laser,cos_angle,sin_angle,variables->n_laser+1,variables->radio_max,0,-2.7,0.0,1,"radar");
	
	float ang_norte=8*3.14*contador_n/450;
    float vel_desp=120.0*contador_n/450;

	ang_norte=variables->angulo_rot;
	plot_brujula(&ang_norte,cos_angle,sin_angle,361,6,3.5,1);

	vel_desp=V*100.0;
	plot_velocimetro(&vel_desp,120,cos_angle,sin_angle,361,6,-1.75,1,"FIJADO");

	vel_desp=variables->velocidad*100.0;
	plot_velocimetro(&vel_desp,120,cos_angle,sin_angle,361,6,-5.5,1,"REAL"); 

	plot_GPS(-6.19,-3.72,1.0);// GPS

    plot_grilla(-0.07,-3.85);
	}

    else if(habilitar_panel && ver_mapa){
    glPrintf(10000,10000,0,"120");
	plot_mapa(-1.75,-0.33,1.0);
	}

    else if(habilitar_panel && ver_cinematica_vel){
    glPrintf(10000,10000,0,"120");

	drawString ("Velocidad [m/s]",18,19.0/256.0,46.0/256.0,144.0/256.0,-1.89,5.67);
	drawString ("Vel Angular [grad/s]",18,19.0/256.0,46.0/256.0,144.0/256.0,-2.36,-0.45);
    
	drawString ("0s",12,19.0/256.0,46.0/256.0,144.0/256.0,-7.88,-6.56);
	drawString ("10s",12,19.0/256.0,46.0/256.0,144.0/256.0,-5.44,-6.56);
	drawString ("20s",12,19.0/256.0,46.0/256.0,144.0/256.0,-2.86,-6.56);
	drawString ("30s",12,19.0/256.0,46.0/256.0,144.0/256.0,-0.27,-6.56);
	drawString ("40s",12,19.0/256.0,46.0/256.0,144.0/256.0,2.27,-6.56);
	drawString ("50s",12,19.0/256.0,46.0/256.0,144.0/256.0,4.87,-6.56);
	drawString ("60s",12,19.0/256.0,46.0/256.0,144.0/256.0,7.47,-6.56);

	plot_cinematica(0.0,2.745,1.0,variables->vec_velocidad,variables->vec_k);
	plot_cinematica(0.0,-3.375,300.0,variables->vec_vel_angulo_rot,variables->vec_k);
	}

    else if(habilitar_panel && ver_cinematica_acel){
    glPrintf(10000,10000,0,"120");

	/*
	drawString ("Aceleracion [m/s  ]",18,19.0/256.0,46.0/256.0,144.0/256.0,-2.19,5.67);
	drawString ("2",10,19.0/256.0,46.0/256.0,144.0/256.0,1.83,5.85);
	drawString ("Acel Angular [grad/s  ]",18,19.0/256.0,46.0/256.0,144.0/256.0,-2.62,-0.45);
	drawString ("2",10,19.0/256.0,46.0/256.0,144.0/256.0,2.28,-0.27);
    */
	
	drawString ("Aceleracion [m/s2]",18,19.0/256.0,46.0/256.0,144.0/256.0,-2.19,5.67);
	drawString ("Acel Angular [grad/s2]",18,19.0/256.0,46.0/256.0,144.0/256.0,-2.62,-0.45);
	
	drawString ("0s",12,19.0/256.0,46.0/256.0,144.0/256.0,-7.88,-6.56);
	drawString ("10s",12,19.0/256.0,46.0/256.0,144.0/256.0,-5.44,-6.56);
	drawString ("20s",12,19.0/256.0,46.0/256.0,144.0/256.0,-2.86,-6.56);
	drawString ("30s",12,19.0/256.0,46.0/256.0,144.0/256.0,-0.27,-6.56);
	drawString ("40s",12,19.0/256.0,46.0/256.0,144.0/256.0,2.27,-6.56);
	drawString ("50s",12,19.0/256.0,46.0/256.0,144.0/256.0,4.87,-6.56);
	drawString ("60s",12,19.0/256.0,46.0/256.0,144.0/256.0,7.47,-6.56);

	plot_cinematica(0.0,2.745,1.0,variables->vec_aceleracion,variables->vec_k);
	plot_cinematica(0.0,-3.375,150.0,variables->vec_acel_angulo_rot,variables->vec_k);
	}

}
