//robot_control.cpp : Defines the entry point for the console application.
//
#include "Aria.h"
#include "ariaUtil.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include "robot_control.h"


#define pi 3.14159265
#define Vmax 0.8 // velocidad maxima
#define Vfre 0.3 // velocidad de frenado
#define L 0.41 // Ancho del eje 
#define paso_grilla 0.1; //paso de grilla

class ConnHandler;
class param_robot;
class robot_control;
class graficos;
class var_robot;
class matriz_grilla;
class grilla;
class sub_grilla;

void matriz_grilla::matriz_obs(int i,int j){

int k=0;
int k_aux=0;

int i_aux_1;
int j_aux_1;
float i_aux_2;
float j_aux_2;

i_aux_2=i/500.0;
j_aux_2=j/500.0;

i_aux_1=(int)i_aux_2;
j_aux_1=(int)j_aux_2;

if(i_aux_2<0)
   i_aux_1--;
if(j_aux_2<0)
   j_aux_1--;

if(i_aux_1<=i_max && i_aux_1>=i_min && j_aux_1<=j_max && j_aux_1>=j_min){

	while(k<=k_matriz){
	
		if(matriz[k].p_m_i==i_aux_1 && matriz[k].p_m_j==j_aux_1)
        k_aux=k;

		k++;
	}

}

else{
k_matriz++;
matriz[k_matriz].cargar_grilla(i_aux_1,j_aux_1);

if(i_aux_1>i_max)
   i_max=i_aux_1;
if(i_aux_1<i_min)
   i_min=i_aux_1;
if(j_aux_1>j_max)
   j_max=j_aux_1;
if(j_aux_1<j_min)
   j_min=j_aux_1;

k_aux=k_matriz;

}

matriz[k_aux].mapa->grilla_obs[i-500*i_aux_1][j-500*j_aux_1]=true;

};

void matriz_grilla::matriz_pos(int i,int j){

};

matriz_grilla::matriz_grilla(void){

printf("hola");

i_min=0;
i_max=0;
j_min=0;
j_max=0;

i_matriz=0;
j_matriz=0;
k_matriz=0;

i_n=255;
j_n=255;

for(int i=0;i<128;i++){
   for(int j=0;j<128;j++){
      obs[i][j]=false;
      rec[i][j]=false;
	  
	  if(i==64 && j==64)
	  rec[i][j]=true;
	  	  
   }
}

//matriz[0].cargar_grilla(0,0);
};


var_robot::var_robot(){

int j=0;
int k=0;
matrix=new matriz_grilla();

habilitar_gps=false;
modo_posicion=0;
tol=0.5;

laser_state=false;
habilitar_laser=true;
detener_marcha=false;
inicio=true;

data_ruta="data_ruta.dat";
data_sick="data_sick.dat";

puerto="COM1";
radio_max=5.0;
modo_comunicacion=0; //Distinto de MobileSim

j_actual = 250; 
k_actual = 250;

pos_X=0.0;
pos_Y=0.0;
angulo_rot=0.0;
velocidad=0.0;
vel_angulo_rot=0.0;
aceleracion=0.0;
acel_angulo_rot=0.0;

tiempo=0.0;


volt_bat=0.0;
tiempo_ant=0.0;

latitud='S';
ang_lat=0;
min_lat=0.0;

longitud='W';
ang_long=0;
min_long=0.0;

desp_X=0.0;
desp_Y=0.0;

for (j=0;j<500;j++){
   for (k=0;k<500;k++){
      grilla_obs[j][k]=false;
      grilla_rec[j][k]=false;
   }
}

grilla_rec[j_actual][k_actual]=true;

for (j=0;j<600;j++){
   vec_velocidad[j]=0;
   vec_vel_angulo_rot[j]=0;
   vec_aceleracion[j]=0;
   vec_acel_angulo_rot[j]=0;
}

for (j=0;j<10000;j++){
   vec_pos_X_UTM[j]=0;
   vec_pos_Y_UTM[j]=0;
   vec_pos_X[j]=0;
   vec_pos_Y[j]=0;
}
X_max=0;
Y_max=0;
vec_k=0;
vec_j=0;
};

void var_robot::actualizar_datos(void){

   vec_velocidad[vec_k]=velocidad;
   vec_vel_angulo_rot[vec_k]=vel_angulo_rot;
   vec_aceleracion[vec_k]=aceleracion;
   vec_acel_angulo_rot[vec_k]=acel_angulo_rot;
   
   if(vec_k<600)
      vec_k++;
   else
	  vec_k=0;

   vec_pos_X_UTM[vec_j]=desp_X;
   vec_pos_Y_UTM[vec_j]=desp_Y;
    
   vec_pos_X[vec_j]=pos_X;
   vec_pos_Y[vec_j]=pos_Y;

   if (desp_X*desp_X>pos_X*pos_X){ 
      if(desp_X>X_max)
		  X_max=desp_X;
	  else if(-desp_X>X_max)
	      X_max=-desp_X;
	  	      //printf("1\n");
   }
   else{
      if(pos_X>X_max)
		  X_max=pos_X;
	  else if(-pos_X>X_max)
	      X_max=-pos_X;
	  	      //printf("2\n");
   }

   if (desp_Y*desp_Y>pos_Y*pos_Y){ 
      if(desp_Y>Y_max)
		  Y_max=desp_Y;
	  else if(-desp_Y>Y_max)
	      Y_max=-desp_Y;
	  	      //printf("3\n");
   }
   else{
      if(pos_Y>Y_max)
		  Y_max=pos_Y;
	  else if(-pos_Y>Y_max)
	      Y_max=-pos_Y;
	  	      //printf("4\n");
   }
   
   //printf("%f %f\n",X_max,Y_max);


   if(vec_j<10000)
      vec_j++;
   else
	  vec_j=0;

   vec_ang=angulo_rot;

};

void var_robot::enter_laser(void){

FILE *descriptor;
float enable=0;
float N_puntos;
int k=0;

    descriptor=fopen(data_sick,"r");
	if (descriptor!=NULL){

    fscanf(descriptor,"%f",&enable);   
	//printf("enable %f\n",enable);
	if (enable==-1.0){

    
	fscanf(descriptor,"%f",&N_puntos);
    //printf("N_puntos %f\n",N_puntos);
    
	if(laser_state==false){
	r_laser = new float[(int)N_puntos-1]; //posicion eje X global;
	printf("inicio laser\n");
    printf("%d\n",(int)-1.45);
	for(int k_p=0;k_p<=10;k_p++)
 	printf("%d\n",k_p);
    	
	
	}
	laser_state=true;

    n_laser=(int)N_puntos-1;
	
	while (fscanf(descriptor,"%f",&r_laser[k])!=EOF){
   	       //printf("%d -> %f\n",k, r_laser[k]);
	    r_laser[k]=r_laser[k]/100;   
		k++;	  
	}

	}

	fclose(descriptor);
	}
    else
    laser_state=false;

};

void var_robot::cargar_ruta(void){

FILE *descriptor;
float enable=0;
float N_puntos;
float X_puntos;
float Y_puntos;

int k=0;

ruta_state=false;
/*
int k_UTM;
float *X_UTM; //valor en mm
float *Y_UTM; //valor en mm
//   n_laser=(int)N_puntos-1;
*/   
    printf(data_ruta); 

	descriptor=fopen(data_ruta,"r");

	if (descriptor!=NULL){    
	    printf("\7\7\n"); 
	    while (fscanf(descriptor,"%f %f",&X_puntos,&Y_puntos)!=EOF){	   
		   k++;	  
		}
	fclose(descriptor);


	k_UTM=k-1;

	//if(X_UTM!=NULL)
	//	delete X_UTM;
	X_UTM=new float[k_UTM];
	
	//if(Y_UTM!=NULL)
	//	delete Y_UTM;
	Y_UTM=new float[k_UTM];
	
	k=0;

	descriptor=fopen(data_ruta,"r");

	if (descriptor!=NULL){    
	
	    while (fscanf(descriptor,"%f %f",&X_puntos,&Y_puntos)!=EOF){
			X_UTM[k]=X_puntos*1000;
			Y_UTM[k]=Y_puntos*1000;
		    printf("punto %d -> %f %f \n",k,X_UTM[k],Y_UTM[k]); 
			k++;	  
		}
	fclose(descriptor);
	}

	ruta_state=true;

	}

	
    else
    ruta_state=false;

};


void var_robot::actualizar_grilla(void){
//paso_grilla
	float i_aux;
	float j_aux;
	int i;
	int j;
	int k;
        
	if(laser_state){

		for(k=0;k<=n_laser;k++){
           i_aux=r_laser[k]*cos(k*pi/360+angulo_rot)/paso_grilla; 
		   j_aux=r_laser[k]*sin(k*pi/360+angulo_rot)/paso_grilla;
		   i=(int)i_aux+k_actual;
		   j=(int)j_aux+j_actual;
	       grilla_obs[i][j]=true;
		   //matrix->matriz_obs(i,j);
		   //system("cls");
		   //printf("%f i= %d j= %d\n",cos(pi/2),i,j);
		}
	}

};

void var_robot::enter_data(ArPose *posicion,ArRobot *robot_aux){
	
	float aux;

	if (inicio){
	pos_X_ini=posicion->getX()/1000.0;
	pos_Y_ini=posicion->getY()/1000.0;
	pos_X=0.0;
	pos_Y=0.0;
	inicio=false;
	}
	else{	
	pos_X=posicion->getX()/1000.0-pos_X_ini;
	pos_Y=posicion->getY()/1000.0-pos_Y_ini;
	}
	
	angulo_rot=posicion->getThRad();
	// carga de velocidades
	velocidad=robot_aux->getVel()/1000.0;
    vel_angulo_rot=robot_aux->getRotVel();
    //carga de aceleraciones
    aceleracion=robot_aux->getTransAccel()/1000.0;
    acel_angulo_rot=robot_aux->getRotAccel();


    // actualizacion de grilla
	aux=-pos_Y/paso_grilla;
    k_actual=(int)aux+250;

	aux=pos_X/paso_grilla;
	j_actual=(int)aux+250;
};

graficos::graficos(){

   int i;
   PI = 3.1415926535897932384626433832795;
   particiones=361;

   cos_aux=new float[particiones-1];
   sin_aux=new float[particiones-1];

   for(i=0;i<particiones;i++){
      cos_aux[i]=cos(i*PI/(particiones-1));
      sin_aux[i]=sin(i*PI/(particiones-1));
   }
   
};

class ConnHandler
{
public:
  // Constructor
  ConnHandler(ArRobot *robot);
  // Destructor, its just empty
  ~ConnHandler(void) {}
  // to be called if the connection was made
  void connected(void);
  // to call if the connection failed
  void connFail(void);
  // to be called if the connection was lost
  void disconnected(void);
protected:
  // robot pointer
  ArRobot *myRobot;
  // the functor callbacks
  ArFunctorC<ConnHandler> myConnectedCB;
  ArFunctorC<ConnHandler> myConnFailCB;
  ArFunctorC<ConnHandler> myDisconnectedCB;
};

/*
  The constructor, note its use of contructor chaining to initalize the 
  callbacks.
*/
ConnHandler::ConnHandler(ArRobot *robot) :
  myConnectedCB(this, &ConnHandler::connected),  
  myConnFailCB(this, &ConnHandler::connFail),
  myDisconnectedCB(this, &ConnHandler::disconnected)

{
  // set the robot poitner
  myRobot = robot;

  // add the callbacks to the robot
  myRobot->addConnectCB(&myConnectedCB, ArListPos::FIRST);
  myRobot->addFailedConnectCB(&myConnFailCB, ArListPos::FIRST);
  myRobot->addDisconnectNormallyCB(&myDisconnectedCB, ArListPos::FIRST);
  myRobot->addDisconnectOnErrorCB(&myDisconnectedCB, ArListPos::FIRST);
}

// just exit if the connection failed
void ConnHandler::connFail(void)
{
  //printf("Failed to connect.\n");
  myRobot->stopRunning();
  Aria::shutdown();
  return;
}

// turn on motors, and off sonar, and off amigobot sounds, when connected
void ConnHandler::connected(void)
{
  ////printf("Connected\n");
  myRobot->comInt(ArCommands::SONAR, 0);
  myRobot->comInt(ArCommands::ENABLE, 1);
  myRobot->comInt(ArCommands::SOUNDTOG, 0);
}

// lost connection, so just exit
void ConnHandler::disconnected(void)
{
  ////printf("Lost connection\n");
  exit(0);
}




class param_robot{

   private:
        
       float *x; //posicion eje X global;
       float *y; //posicion eje y global;
       double *r_theta; //posicion eje y global;
       float *r_phi; //posicion eje y global;

	   float *VL; //velocidad rueda izquierda;
	   float *VR; //velocidad rueda izquierda;
       float *r; //velocidad rueda izquierda;
       float *T; //velocidad rueda izquierda;


	   float *t_v_x; //velocidad eje X global;
	   float *t_v_y; //velocidad eje Y global;
  	   
	   float r_x; //posicion eje X global;
       float r_y; //posicion eje y global;
	   
	   float v_x; //velocidad eje X global;
	   float v_y; //velocidad eje Y global;
       
	   float a_x; //aceleracion eje X global;
       float a_y; //aceleracion eje y global;

       float theta;  //posicion angular eje Z global
	   float w;      //velocidad angular eje Z global
	   float alpha;  //aceleracion angular eje Z global
	   	   
	   float DR;

   public:
       
	   int   N_etapas;  //aceleracion angular eje Z global
       int   N_pasos;
	   int   k_pasos;

       param_robot(void); //constructor
	   ~param_robot(void){
	      
/*	   if (x!=NULL)
	   delete x; //posicion eje X global;
	   if (y!=NULL)
       delete y; //posicion eje y global;
	   if (r_theta!=NULL)
       delete r_theta; //posicion eje y global;
	   if (r_phi!=NULL)
       delete r_phi; //posicion eje y global;

	   if (VL!=NULL)
	   delete VL; //velocidad rueda izquierda;
	   if (VR!=NULL)
	   delete VR; //velocidad rueda izquierda;
	   if (r!=NULL)
       delete r; //velocidad rueda izquierda;
	   if (T!=NULL)
       delete T; //velocidad rueda izquierda;

	   if (t_v_x!=NULL)
       delete t_v_x; //velocidad eje X global;
	   if (t_v_y!=NULL)
	   delete t_v_y; //velocidad eje Y global;*/

	   };//destructor

       void display_data(void);
	   void trayectoria(void);
       int readFile(char *filename);
       float phi(int j);
	   void set_vel(int j,ArRobot *robot_aux);
	   void set_vel();
	   void run_vel(ArRobot *robot_aux,ArPose *posicion_aux);
	   void set_run_vel(ArRobot *robot_aux,ArPose *posicion_aux,ArTime *start_aux);
	   void linea_recta(ArRobot *robot_aux,ArPose *posicion_aux,ArPose *posicion_ini,ArPose *posicion_fin,bool *stop,bool *continuar,var_robot *variables);
	   void modo_manual(ArRobot *robot_aux,ArPose *posicion_aux,ArPose *posicion_fin,ArTime *start,bool *stop,bool *continuar,float *VR_f,float *VL_f,var_robot *variables);
       int detectar_obstaculo(var_robot *variables);    
};

param_robot::param_robot(void){

	r_x=0; //posicion eje X global;
    r_y=0; //posicion eje y global;

	   
	v_x=3.25; //velocidad eje X global;
	v_y=0; //velocidad eje Y global;
       
	a_x=0; //aceleracion eje X global;
    a_y=0; //aceleracion eje y global;

    theta=0;  //posicion angular eje Z global
	w=0;      //velocidad angular eje Z global
	alpha=0;  //aceleracion angular eje Z global
    N_etapas=1000;
    k_pasos=0;
}


float param_robot::phi(int j){
	float r_aux;   
	
	if (j < N_etapas-1){
	r_phi[j]=r_theta[j+1]-r_theta[j]; 
    r_aux=r_phi[j];}

	else{
    r_phi[N_etapas-1]=r_theta[N_etapas-1]-r_theta[N_etapas-2];
    r_aux=r_phi[N_etapas-1];}
    	
	return r_aux;
}


void param_robot::set_vel(int j,ArRobot *robot_aux){

float T;
float TL;
float TR;

//r[j]=DR;

r_phi[j]=r_theta[j+1]-r_theta[j];

if (r_phi[j]==0){    
   T=r[j]/Vmax;
   VL[j]=Vmax;    
   VR[j]=Vmax;}
else{
//   ArUtil::sleep(10);
   TL= ((cos(r_phi[j])+1)/(2*sin(r_phi[j]))*r_phi[j]*DR-L*r_phi[j]/2)/Vmax;
   TR= ((cos(r_phi[j])+1)/(2*sin(r_phi[j]))*r_phi[j]*DR+L*r_phi[j]/2)/Vmax;
   
   if (TR <0)
   TR=-TR;
   if (TL <0)
   TL=-TL;

   if (TR > TL)
   T= TR;
   else
   T= TL;

   VL[j]=(cos(r_phi[j])+1)/(2*T*sin(r_phi[j]))*r_phi[j]*DR-L*r_phi[j]/2/T;
   VR[j]=(cos(r_phi[j])+1)/(2*T*sin(r_phi[j]))*r_phi[j]*DR+L*r_phi[j]/2/T;    
    
}


robot_aux->setVel2(VL[j]*1000,VR[j]*1000); 
ArUtil::sleep(abs(T*1000));
}

void param_robot::set_vel(){

float TL;
float TR;
float phi_aux;
int j=0;
//r[j]=DR;
for(j=0;j<N_etapas-1;j++){

phi_aux=r_theta[j+1]-r_theta[j];

if (phi_aux<-pi)
phi_aux=phi_aux+2*pi;

if (phi_aux>pi)
phi_aux=phi_aux-2*pi;

if (phi_aux==0){    
   T[j]=r[j]/Vmax;
   VL[j]=Vmax;    
   VR[j]=Vmax;}
else{
//   ArUtil::sleep(10);
   TL= ((cos(phi_aux)+1)/(2*sin(phi_aux))*phi_aux*DR-L*phi_aux/2)/Vmax;
   TR= ((cos(phi_aux)+1)/(2*sin(phi_aux))*phi_aux*DR+L*phi_aux/2)/Vmax;
   
   if (TR <0)
   TR=-TR;
   if (TL <0)
   TL=-TL;

   if (TR > TL)
   T[j]= TR;
   else
   T[j]= TL;

   VL[j]=((cos(phi_aux)+1)/(2*T[j]*sin(phi_aux))*phi_aux*DR-L*phi_aux/2/T[j])*1000;
   VR[j]=((cos(phi_aux)+1)/(2*T[j]*sin(phi_aux))*phi_aux*DR+L*phi_aux/2/T[j])*1000;    
    
}
//robot_aux->setVel2(VR[j],VL[j]); 
//ArUtil::sleep(abs(T[j]*1000));
}
}

void param_robot::set_run_vel(ArRobot *robot_aux,ArPose *posicion_aux,ArTime *start_aux){

float TL;
float TR;
float phi_aux;
float rx_aux;
float ry_aux;
float tan_aux;
float time;
int j=0;
//r[j]=DR;
for(j=0;j<N_etapas-1;j++){
        
        time=start_aux->mSecSince();
        rx_aux=(x[j+1]-posicion_aux->getX()/1000);
        ry_aux=(y[j+1]-posicion_aux->getY()/1000);

		
		r[j]=sqrt(rx_aux*rx_aux+ry_aux*ry_aux);
 
		tan_aux=ry_aux/rx_aux;
        
		if (tan_aux <0){
			tan_aux=-tan_aux;}

        if (rx_aux>0 && ry_aux>0){  //cuadrante 1
            r_theta[j]=atan(tan_aux);
		}
        else if (rx_aux<=0 && ry_aux>0){ //cuadrante 2
            r_theta[j]=pi-atan(tan_aux);
		}
        else if (rx_aux<=0 && ry_aux<=0){ //cuadrante 3
            r_theta[j]=-pi+atan(tan_aux);
		}
        else if (rx_aux>0 && ry_aux<=0){ //cuadrante 4
            r_theta[j]=-atan(tan_aux);
		}




if (j>0)
phi_aux=r_theta[j]-r_theta[j-1];
else
phi_aux=r_theta[0];


if (phi_aux<-pi)
phi_aux=phi_aux+2*pi;

if (phi_aux>pi)
phi_aux=phi_aux-2*pi;

if (phi_aux==0){    
   T[j]=r[j]/Vmax;
   VL[j]=Vmax;    
   VR[j]=Vmax;}
else{
//   ArUtil::sleep(10);
   TL= ((cos(phi_aux)+1)/(2*sin(phi_aux))*phi_aux*r[j]-L*phi_aux/2)/Vmax;
   TR= ((cos(phi_aux)+1)/(2*sin(phi_aux))*phi_aux*r[j]+L*phi_aux/2)/Vmax;
   
   if (TR <0)
   TR=-TR;
   if (TL <0)
   TL=-TL;

   if (TR > TL)
   T[j]= TR;
   else
   T[j]= TL;

   VL[j]=((cos(phi_aux)+1)/(2*T[j]*sin(phi_aux))*phi_aux*r[j]-L*phi_aux/2/T[j])*1000;
   VR[j]=((cos(phi_aux)+1)/(2*T[j]*sin(phi_aux))*phi_aux*r[j]+L*phi_aux/2/T[j])*1000;    
    
}

posicion_aux->setPose(robot_aux->getRawEncoderPose());

robot_aux->setVel2(VL[j],VR[j]); 



time=(T[j]*1000+time-start_aux->mSecSince());
 
if (time>0)
ArUtil::sleep(int(time));

}
}

void param_robot::run_vel(ArRobot *robot_aux,ArPose *posicion_aux){
	int j=0;
	double VRaux;
    double VLaux;

	for(j=0;j<N_etapas-2;j++){
    
    VRaux=VR[j];
    VLaux=VL[j];
    posicion_aux->setPose(robot_aux->getRawEncoderPose());
    //printf("[%lf] [%lf]\n",posicion_aux->getX()/1000.0,posicion_aux->getY()/1000.0);
    robot_aux->setVel2(VRaux,VLaux); 
    ArUtil::sleep(abs(T[j]*1000.0));}
}

int param_robot::detectar_obstaculo(var_robot *variables){

	int k=136;
	float r_min=100.0;
    int zona_1=0;      
    int zona_2=0;      
	
	if(variables->laser_state && variables->habilitar_laser && variables->r_laser!=NULL){//el laser esta encendido
     
		for(k=136;k<224;k++){
	    
		    if(r_min>variables->r_laser[k])
			r_min=variables->r_laser[k];
		    
			if(variables->r_laser[k]<1.1)
		    zona_2++;  
            
			else if(variables->r_laser[k]<2.2) 
		    zona_1++;
		}
		
		if(zona_2>17)
	       return 2;
		if(r_min<0.8)
	       return 2;

		if(zona_1>17)
	       return 1;
		if(r_min<2.0)
	       return 1;

	    return 0;
	}
	else
	   return 0;
};

void param_robot::linea_recta(ArRobot *robot_aux,ArPose *posicion_aux,ArPose *posicion_ini,ArPose *posicion_fin,bool *stop,bool *continuar,var_robot *variables){
int regla;
bool positivo;
int cuad_ini;
int cuad_fin;
float T_aux;
float VL_aux;
float VR_aux;
float w_aux;
float r_aux=0;
float r_rec=0;
float radio=0;
float radio_max=0;
float error_ang=0;
float error_ang_ini=0;
float phi_aux;
float delta_phi;
float delta_phi_ini;
float k_prop=1;
int k=0;
bool reiniciar_marcha=false;
ArPose posicion_aux_2;

*continuar=0;
if (variables->modo_comunicacion==0)
posicion_aux->setPose(robot_aux->getEncoderPose());
else
posicion_aux->setPose(robot_aux->getRawEncoderPose());

variables->enter_data(posicion_aux,robot_aux);
posicion_aux->setX(variables->pos_X*1000);
posicion_aux->setY(variables->pos_Y*1000);

//phi_aux = posicion_aux->findAngleTo(*posicion_fin);
phi_aux = posicion_ini->findAngleTo(*posicion_fin);

/*if (phi_aux==180.0 && posicion_aux->getTh()<0)
phi_aux=-180.0;*/

if(posicion_aux->getTh() >=0 && posicion_aux->getTh()<90)
cuad_ini=1;
else if(posicion_aux->getTh() >=90)
cuad_ini=2;
else if(posicion_aux->getTh() <=-90)
cuad_ini=3;
else if(posicion_aux->getTh() < 0 && posicion_aux->getTh()>-90)
cuad_ini=4;

if(phi_aux >=0 && phi_aux<90)
cuad_fin=1;
else if(phi_aux >=90)
cuad_fin=2;
else if(phi_aux <=-90)
cuad_fin=3;
else if(phi_aux < 0 && phi_aux>-90)
cuad_fin=4;



//calculo de rotacion

//primer cuadrante
if(cuad_ini==1 && cuad_fin==1){
   if (phi_aux-posicion_aux->getTh()>=0)
   positivo=true;
   else
   positivo=false;
   regla=1;
}
else if(cuad_ini==1 && cuad_fin==2){
   positivo=true;
   regla=2;
}
else if(cuad_ini==1 && cuad_fin==3){
   if (360+phi_aux-posicion_aux->getTh()<=180)
   positivo=true;
   else
   positivo=false;
   regla=3;
}
else if(cuad_ini==1 && cuad_fin==4){
   positivo=false;
   regla=4;
}
//segundo cuadrante
else if(cuad_ini==2 && cuad_fin==1){
   positivo=false;
   regla=5;
}
else if(cuad_ini==2 && cuad_fin==2){
   if (phi_aux-posicion_aux->getTh()>=0)
   positivo=true;
   else
   positivo=false;
   regla=6;
}
else if(cuad_ini==2 && cuad_fin==3){
   positivo=true;
   regla=7;
}
else if(cuad_ini==2 && cuad_fin==4){
   if (360+phi_aux-posicion_aux->getTh()<=180)
   positivo=true;
   else
   positivo=false;
   regla=8;
}

//tercer cuadrante
else if(cuad_ini==3 && cuad_fin==1){
   if (360+posicion_aux->getTh()-phi_aux<=180)
   positivo=false;
   else
   positivo=true;
   regla=9;
}
else if(cuad_ini==3 && cuad_fin==2){
   positivo=false;
   regla=10;
}
else if(cuad_ini==3 && cuad_fin==3){
   if (phi_aux-posicion_aux->getTh()>=0)
   positivo=true;
   else
   positivo=false;
   regla=11;
}
else if(cuad_ini==3 && cuad_fin==4){
   positivo=true;
   regla=12;
}

//cuarto cuadrante
else if(cuad_ini==4 && cuad_fin==1){
   positivo=true;
   regla=13;
}
else if(cuad_ini==4 && cuad_fin==2){
   if (360+posicion_aux->getTh()-phi_aux<=180)
   positivo=false;
   else
   positivo=true;
   regla=14;
}
else if(cuad_ini==4 && cuad_fin==3){
   positivo=false;
   regla=15;
}
else if(cuad_ini==4 && cuad_fin==4){
   if (phi_aux-posicion_aux->getTh()>=0)
   positivo=true;
   else
   positivo=false;
   regla=16;
}

//if(phi_aux>0){
if(positivo==true){
w_aux=2*Vmax*0.03/L;
VL_aux=-Vmax*0.03;
VR_aux=+Vmax*0.03;}
else{
w_aux=-2*Vmax*0.03/L;
VL_aux=+Vmax*0.03;
VR_aux=-Vmax*0.03;}



/*if(phi_aux>180) 
phi_aux=phi_aux-360;
else if(phi_aux<-180) 
phi_aux=phi_aux+360;*/

printf("angulo inicial %f\n", posicion_aux->getTh());
printf("angulo phi     %f\n", phi_aux);

T_aux=phi_aux/w_aux;

if (variables->modo_comunicacion==0)
posicion_aux->setPose(robot_aux->getEncoderPose());
else
posicion_aux->setPose(robot_aux->getRawEncoderPose());

variables->enter_data(posicion_aux,robot_aux);
posicion_aux->setX(variables->pos_X*1000);
posicion_aux->setY(variables->pos_Y*1000);

printf("[%lf] [%lf] [%lf]\n",posicion_aux->getX()/1000.0,posicion_aux->getY()/1000.0,posicion_aux->getTh());

robot_aux->setVel2(0.0,0.0);
 
if (variables->modo_comunicacion==0)
delta_phi=(phi_aux-robot_aux->getEncoderPose().getTh());
else
delta_phi=(phi_aux-robot_aux->getRawEncoderPose().getTh());

/*if(delta_phi>180) 
delta_phi=delta_phi-360;
else if(delta_phi<-180) 
delta_phi=delta_phi+360;
*/
/*if(delta_phi>0){
w_aux=2*Vmax*0.08/L;
VL_aux=-Vmax*0.08;
VR_aux=+Vmax*0.08;}
else{
w_aux=-2*Vmax*0.08/L;
VL_aux=+Vmax*0.08;
VR_aux=-Vmax*0.08;}
*/
robot_aux->setVel2(VL_aux*1000,VR_aux*1000);

variables->enter_data(posicion_aux,robot_aux);
posicion_aux->setX(variables->pos_X*1000);
posicion_aux->setY(variables->pos_Y*1000);

while (delta_phi>1.0 ||delta_phi<-1.0 ){

if (variables->modo_comunicacion==0){
delta_phi=(phi_aux-robot_aux->getEncoderPose().getTh());
posicion_aux->setPose(robot_aux->getEncoderPose());}
else{
delta_phi=(phi_aux-robot_aux->getRawEncoderPose().getTh());
posicion_aux->setPose(robot_aux->getRawEncoderPose());}

variables->enter_data(posicion_aux,robot_aux);
posicion_aux->setX(variables->pos_X*1000);
posicion_aux->setY(variables->pos_Y*1000);
/*
system("cls");
printf("angulo inicial %f\n", posicion_aux->getTh());
printf("angulo phi     %f\n", phi_aux);
printf("delta phi      %f\n", delta_phi);
printf("velocidad de giro     %f\n", w_aux);
printf("regla %d--> %d fin %f ini %f \n",regla,positivo,phi_aux,posicion_aux->getTh());
*/

reiniciar_marcha=false;

while(variables->detener_marcha){
//*continuar=1;
robot_aux->setVel2(0,0);
//return;
reiniciar_marcha=true;
}

if(reiniciar_marcha){
reiniciar_marcha=false;
robot_aux->setVel2(VL_aux*1000,VR_aux*1000);
}


}

robot_aux->setVel2(0,0);

ArUtil::sleep(1000);

if (variables->modo_comunicacion==0)
posicion_aux->setPose(robot_aux->getEncoderPose());
else
posicion_aux->setPose(robot_aux->getRawEncoderPose());

variables->enter_data(posicion_aux,robot_aux);
posicion_aux->setX(variables->pos_X*1000);
posicion_aux->setY(variables->pos_Y*1000);
printf("[%lf] [%lf] [%lf]\n",posicion_aux->getX()/1000.0,posicion_aux->getY()/1000.0,posicion_aux->getTh());
r_aux=posicion_aux->findDistanceTo(*posicion_fin); 
radio_max=r_aux;

if (r_aux>3000)
robot_aux->setVel2(Vmax*1000,Vmax*1000); 
else 
robot_aux->setVel2(Vfre*1000,Vfre*1000); 

//error_ang_ini=posicion_aux->getTh();
//printf("\n angulo error %f \n",posicion_aux->findAngleTo(*posicion_fin));

posicion_aux_2.setPose(*posicion_aux);
while (r_rec<=radio_max){

int tipo_obstaculo=detectar_obstaculo(variables);



while(variables->detener_marcha){
robot_aux->setVel2(0,0);
}


if(tipo_obstaculo==0){

if (r_aux>3000)
robot_aux->setVel2(Vmax*1000,Vmax*1000); 
else 
robot_aux->setVel2(Vfre*1000,Vfre*1000); 
	
if (radio_max-r_rec < 2000)
robot_aux->setVel2(Vfre*1000,Vfre*1000); 

}
else if(tipo_obstaculo==1){
robot_aux->setVel2(Vfre*1000,Vfre*1000); 
}
else if(tipo_obstaculo==2){
robot_aux->setVel2(0.0,0.0); 
}




if (variables->modo_comunicacion==0)
posicion_aux->setPose(robot_aux->getEncoderPose());
else
posicion_aux->setPose(robot_aux->getRawEncoderPose());

variables->enter_data(posicion_aux,robot_aux);
posicion_aux->setX(variables->pos_X*1000);
posicion_aux->setY(variables->pos_Y*1000);
//error_ang=posicion_aux->findAngleTo(*posicion_fin)-error_ang_ini;
r_rec=r_rec+posicion_aux->findDistanceTo(posicion_aux_2);
posicion_aux_2.setPose(*posicion_aux);
system("cls");
printf("distancia %f ",r_rec);

}

robot_aux->setVel2(0,0);
ArUtil::sleep(1000);
*continuar=1;

phi_aux=posicion_aux->findAngleTo(*posicion_fin);
printf("\n angulo error %f \n",phi_aux);

}


void param_robot::modo_manual(ArRobot *robot_aux,ArPose *posicion_aux,ArPose *posicion_fin,ArTime *start, bool *stop,bool *continuar,float *VR_f,float *VL_f,var_robot *variables){

int k=0;

if (variables->modo_comunicacion==0)
posicion_aux->setPose(robot_aux->getEncoderPose());
else
posicion_aux->setPose(robot_aux->getRawEncoderPose());


printf("[%lf] [%lf] [%lf]\n",posicion_aux->getX()/1000.0,posicion_aux->getY()/1000.0,posicion_aux->getTh());

while (*continuar){

if (variables->modo_comunicacion==0)
posicion_aux->setPose(robot_aux->getEncoderPose());
else
posicion_aux->setPose(robot_aux->getRawEncoderPose());

/*variables->pos_X=posicion_aux->getX()/1000.0;
variables->pos_Y=posicion_aux->getY()/1000.0;
variables->angulo_rot=posicion_aux->getTh();*/
//variables->enter_data(posicion_aux,1.0);
if (k==10){
variables->enter_data(posicion_aux,robot_aux);
//ArUtil::sleep(50);
k=0;
}
else
k++;

//start->setToNow();
//printf("%f\n",start->getSec());
// algoritmo de velocidades

robot_aux->setVel2(*VR_f*1000,*VL_f*1000);
//start->setToNow();
//ArUtil::sleep(1000);
}

}



void param_robot::display_data(){

	//printf("posicion    [ %f , %f ] m        \n",r_x,r_y,theta);
	//printf("velocidad   [ %f , %f ] m/s      \n",v_x,v_y,w);
	//printf("aceleracion [ %f , %f ] m/s^2    \n\n\n",a_x,a_y,alpha);

	
    //printf("theta [ %f ] rad\n",theta);
    //printf("w     [ %f ] rad/s\n",w);
    //printf("alpha [ %f ] rad/s^2\n\n\n",alpha);


}

int param_robot::readFile(char *filename){

	float file_X;
    float file_Y;
    double rx_aux=0;
    double ry_aux=0;
    double tan_aux=0;
    
	int k=0;

	N_pasos=0;


	FILE *descriptor;
	descriptor=fopen(filename,"r");

    fscanf(descriptor,"%d %f",&N_etapas,&DR);

    x  = new float[N_etapas-1]; //posicion eje X global;
    y  = new float[N_etapas-1]; //posicion eje y global;
	VL = new float[N_etapas-1]; //velocidad rueda izquierda;
	VR = new float[N_etapas-1]; //velocidad rueda izquierda;
    r  = new float[N_etapas-1]; //longitud de desplazamiento;
    T = new float[N_etapas-1]; 

	int count=0;
	while (fscanf(descriptor,"%f %f",&file_X,&file_Y)!=EOF){

      
	   x[k]=file_X; 
       y[k]=file_Y; 
   	   k++;
	   count++;
	}

	N_pasos=k;
	fclose(descriptor);
    
	r_theta = new double[N_etapas-1];

    for(k=0;k<N_pasos;k++){

        rx_aux=(x[k+1]-x[k]);
        ry_aux=(y[k+1]-y[k]);

		tan_aux=ry_aux/rx_aux;
        
		if (tan_aux <0){
			tan_aux=-tan_aux;}

        if (rx_aux>0 && ry_aux>0){  //cuadrante 1
            r_theta[k]=atan(tan_aux);
		}
        else if (rx_aux<=0 && ry_aux>0){ //cuadrante 2
            r_theta[k]=pi-atan(tan_aux);
		}
        else if (rx_aux<=0 && ry_aux<=0){ //cuadrante 3
            r_theta[k]=-pi+atan(tan_aux);
		}
        else if (rx_aux>0 && ry_aux<=0){ //cuadrante 4
            r_theta[k]=-atan(tan_aux);
		}
      //printf("theta = %f \n",r_theta[k]);
	}



return 0;
}


void param_robot::trayectoria(void){

int k=0;
float rx_aux=0;
float ry_aux=0;
float r_aux=0;

r_theta = new double[N_pasos]; //posicion eje X global;


for(k=0;k<N_pasos;k++){

   rx_aux=(x[k+1]-x[k]);
   ry_aux=(y[k+1]-y[k]);

   r_aux=sqrt(rx_aux*rx_aux+ry_aux*ry_aux);
   
   if (rx_aux>0 && ry_aux>0){  //cuadrante 1
      r_theta[k]=atan(abs(ry_aux/rx_aux));
   }
   else if (rx_aux<=0 && ry_aux>0){ //cuadrante 2
      r_theta[k]=pi-atan(abs(ry_aux/rx_aux));
   }
   else if (rx_aux<=0 && ry_aux<=0){ //cuadrante 3
	  r_theta[k]=-pi+atan(abs(ry_aux/rx_aux));
   }
   else if (rx_aux>0 && ry_aux<=0){ //cuadrante 4
      r_theta[k]=-atan(abs(ry_aux/rx_aux));
   }    


}

}


void body(ArPose *desp){

    int k=1;
	param_robot *datos = new param_robot;
	datos->readFile("datos.txt");


}



class robot_control{

   private:
       const char *str;
       int ret;  
       ArPose *desp; //inicializacion de direcciones
       ArPose *posicion;
       ArPose *meta;
	   ArPose *inicio;
       ArTime *start; 
       ArTcpConnection *con;
	   ArSerialConnection  *con_s;// connection to the robot
       ArAnalogGyro *gyro;
       param_robot *datos;  
       char *p_serial;
	   char *IP;
	   int port;
	   int tipo_conexion;

   public:
   bool stop;
   bool continuar;
   ArRobot *robot;  // the robot
   ConnHandler *ch;
   int main_robot(var_robot *variables);
   int manual_robot(float *VR,float *VL,bool *activo,var_robot *variables);
   robot_control(char *IP_enter,int port_enter);
   robot_control(char *PUERTO);
   ~robot_control(void){
   
//   delete str;
/*   if (desp!=NULL)
   delete desp; //inicializacion de direcciones
   if (posicion!=NULL)
   delete posicion;
   if (meta!=NULL)
   delete meta;
   if (start!=NULL)
   delete start; 
   if (con!=NULL)
   delete con;
   if (con_s!=NULL)
   delete con_s;// connection to the robot
   if (robot!=NULL)
   delete robot;  // the robot
   if (gyro!=NULL)
   delete gyro;
   if (ch!=NULL)
   delete ch;
   if (datos!=NULL)
   delete datos;  
   if (p_serial!=NULL)
   delete p_serial;
   if (IP!=NULL)
   delete IP;*/
   
   
   };//destructor       
};

robot_control::robot_control(char *IP_enter,int port_enter){
	tipo_conexion=0;
	printf("\7->1\n");
	IP=IP_enter; 
    port=port_enter;
	stop=0;
    continuar=1;
    printf("\7->2\n");

    // the connection handler from above
    robot = new ArRobot;	
    ch= new ConnHandler(robot);
    datos=new param_robot;
	desp=new ArPose; //inicializacion de direcciones
    posicion=new ArPose;
    meta=new ArPose;
	inicio=new ArPose;
    con= new ArTcpConnection;
	start=new ArTime;
	printf("\7->3\n");

}

robot_control::robot_control(char *PUERTO){

	tipo_conexion=1;
	printf("\7->1\n");
	stop=0;
    continuar=1;
    printf("\7->2\n");
	//p_serial=new char[10];
	//printf(PUERTO);
    p_serial=PUERTO;
    //p_serial="com8";
	printf(p_serial);
    
    // the connection handler from above
    //con_s= new ArSerialConnection;
	//robot = new ArRobot;	
    //ch= new ConnHandler(robot);
    datos=new param_robot;
	desp=new ArPose; //inicializacion de direcciones
    posicion=new ArPose;
    meta=new ArPose;
	inicio=new ArPose;    
	start=new ArTime;
	printf("\7-2c>3\n");

}


int robot_control::main_robot(var_robot *variables){


  //printf("************************\n");

  // init area with a dedicated signal handling thread

  if(tipo_conexion==0){
  
  Aria::init(Aria::SIGHANDLE_THREAD); //printf("5\n");
  
  if ((ret = con->open(IP,port)) != 0){
    str = con->getOpenMessage(ret);
    printf("Open failed: %s\n", str);
    Aria::shutdown();
    return 1;}

  robot->setDeviceConnection(con);
  
  if (!robot->blockingConnect()){
    printf("asyncConnect failed because robot is not running in its own thread.\n");
  	Aria::shutdown();
    return 1;}

  }
     
    robot->runAsync(true);
    //datos->readFile("datos.txt");
    //datos->set_vel();
    gyro = new ArAnalogGyro(robot);
    gyro->activate();
	
    /***************************************/  
    robot->setConnectionTimeoutTime(10000);//tiempo maximo sin recibir seal
	posicion->setPose(0.84317032,0.81201786,0.857);
	robot->setEncoderTransform(*posicion);

	robot->setEncoderTransform(*posicion);
	
	
	
    printf("Tiempo conexion maxima: %d \n",robot->getConnectionTimeoutTime());
    printf("Voltaje Baterias : %f \n",robot->getRealBatteryVoltageNow());

    variables->cargar_ruta();   

	//ArUtil::sleep(5000);
    //gyro->setFilterModel(0,0,0,0);

	
//	datos->run_vel(robot,&posicion);
//	datos->set_run_vel(robot,&posicion,&start);

    printf("corriendo ruta fijada\n");
	
    posicion->setPose(0.0,0.0,0.0);
    
//	printf("hola");
	start->setToNow();
    if(variables->ruta_state){
       for(int k=0;k<=variables->k_UTM-1;k++){        
	   
		  if (variables->modo_posicion==1){
		  variables->X_UTM[k]=variables->pos_X*1000;
		  variables->Y_UTM[k]=variables->pos_Y*1000;}
		  else if (variables->modo_posicion==2 && variables->habilitar_gps){
		  variables->X_UTM[k]=variables->desp_X*1000;
		  variables->Y_UTM[k]=variables->desp_Y*1000;}
		  else if (variables->modo_posicion==3 && variables->habilitar_gps){
		  variables->X_UTM[k]=(variables->pos_X*variables->tol+variables->desp_X*(1-variables->tol))*1000;
		  variables->Y_UTM[k]=(variables->pos_Y*variables->tol+variables->desp_Y*(1-variables->tol))*1000;}

	      inicio->setPose(variables->X_UTM[k],variables->Y_UTM[k],0.0);
	      meta->setPose(variables->X_UTM[k+1],variables->Y_UTM[k+1],0.0);
	      datos->linea_recta(robot,posicion,inicio,meta,&stop,&continuar,variables);	
	      robot->lock();

          if (variables->modo_comunicacion==0)
	      printf("\nencoder %f %f %f\n",robot->getEncoderPose().getX(),robot->getEncoderPose().getY(),robot->getEncoderPose().getTh());
	      else
	      printf("\nencoder %f %f %f\n",robot->getRawEncoderPose().getX(),robot->getRawEncoderPose().getY(),robot->getRawEncoderPose().getTh());
	
	      robot->unlock();

	   }
	}

	printf("[%f] [%f]\n",robot->getVel(),robot->getY());
	printf("\7\n\n%d\n",start->mSecSince()); 	
    //printf("\7\n\n%d\n",start.mSecSince());
	robot->lock();
    
    if (variables->modo_comunicacion==0)
	printf("\nencoder %f %f %f\n",robot->getEncoderPose().getX(),robot->getEncoderPose().getY(),robot->getEncoderPose().getTh());
	else
	printf("\nencoder %f %f %f\n",robot->getRawEncoderPose().getX(),robot->getRawEncoderPose().getY(),robot->getRawEncoderPose().getTh());
	
	robot->unlock();


	//printf("\nencoder 2 %f\n",posicion.getX());
	//robot->getEncoderPoseInterpPosition(start,&posicion); 
	//printf("\nencoder 2 %f\n",posicion.getX());


	printf("\nexiste %d activo %d paquetes %d\n",gyro->haveGottenData(),gyro->isActive(),gyro->getPacCount());
	Aria::shutdown();


	return 0;

 
}


int robot_control::manual_robot(float *VR,float *VL,bool *activo,var_robot *variables){

  //printf("************************\n");

  // init area with a dedicated signal handling thread
  //Aria::init(Aria::SIGHANDLE_THREAD); //printf("5\n");


  if(tipo_conexion==0){

  Aria::init(Aria::SIGHANDLE_THREAD); //printf("5\n");
  
  
  if ((ret = con->open(IP,port)) != 0){
    str = con->getOpenMessage(ret);
    printf("Open failed: %s\n", str);
    Aria::shutdown();
    return 1;}

  robot->setDeviceConnection(con);
  
  if (!robot->blockingConnect()){
    printf("asyncConnect failed because robot is not running in its own thread.\n");
  	Aria::shutdown();
    return 1;}

  }
  /*else{
  con_s->setPort(p_serial);
  
    if ((ret = con_s->open()) != 0){
    str = con_s->getOpenMessage(ret);
    printf("Open failed: %s\n", str);
    Aria::shutdown();
    return 1;}

  robot->setDeviceConnection(con_s);
  
  if (!robot->blockingConnect()){
    printf("asyncConnect failed because robot is not running in its own thread.\n");
  	Aria::shutdown();
    return 1;}
     
  }*/
    robot->runAsync(true);
    //datos->readFile("datos.txt");
    //datos->set_vel();
    gyro = new ArAnalogGyro(robot);
    gyro->activate();
	
    /***************************************/  
    robot->setConnectionTimeoutTime(10000);//tiempo maximo sin recibir seal
	//posicion->setPose(0.84317032,0.81201786,0.96968483);
	posicion->setPose(1.0,1.0,0.857);
	robot->setEncoderTransform(*posicion);
	robot->runAsync(true);
	
	
    printf("Tiempo conexion maxima: %d \n",robot->getConnectionTimeoutTime());
    printf("Voltaje Baterias : %f \n",robot->getRealBatteryVoltageNow());

    printf("run");
    meta->setPose(2000.0,2000.0,0.0);
    posicion->setPose(0.0,0.0,0.0);
    
	printf("hola");
	start->setToNow();

    if(*activo){
	datos->modo_manual(robot,posicion,meta,start,&stop,activo,VR,VL,variables);
    }
    
	
	return 0;
}


int main_(char *IP,int port,var_robot *variables){

  
  //char *IP = "127.0.0.1";
  //char *IP = "192.168.1.99";
  //int  port= 8101;
  printf("1c\n");
  robot_control controler(IP,port);
  printf("2c\n");
  controler.main_robot(variables);
  printf("3c\n");
  return 0;
}



int main_manual(char *IP,int port,float *VR,float *VL,bool *continuar,var_robot *variables){

  
  //char *IP = "127.0.0.1";
  //char *IP = "192.168.1.99";
  //int  port= 8101;
  printf("1c\n");
  robot_control controler(IP,port);
  printf("2c\n");
  controler.manual_robot(VR,VL,continuar,variables);
  printf("3c\n");
  return 0;
}

int main_manual_serial(char *PUERTO,float *VR,float *VL,bool *continuar,var_robot *variables){

  const char *str;
  int ret;
  //printf("%d\n",argc);
  char *IP = "127.0.0.1";
  //char *IP = "192.168.1.99";
  int  port= 8101;	
  robot_control controler(PUERTO);

  printf("0\n");

  ArPose desp; //inicializacion de direcciones
  ArSerialConnection con; 
  ArRobot *robot;
  robot = new ArRobot;
  ConnHandler ch(robot);
  /*var_robot *variables;
  variables =new var_robot();
*/
  // init area with a dedicated signal handling thread
  Aria::init(Aria::SIGHANDLE_THREAD); printf("5\n");
  
 
  if ((ret = con.open(PUERTO)) != 0)

  {
    str = con.getOpenMessage(ret);
    printf("Open failed: %s\n", str);
	//body();
    Aria::shutdown();
    return 1;
  }
  robot->setDeviceConnection(&con);
  if (!robot->blockingConnect())
  {
    printf(
    "asyncConnect failed because robot is not running in its own thread.\n");
    //body();
	Aria::shutdown();
    return 1;
  }

  robot->runAsync(true); 
  controler.robot=robot;
  controler.manual_robot(VR,VL,continuar,variables);
  Aria::shutdown();
  return 0;


/*  printf("1c\n");
  robot_control controler(PUERTO);
  printf("2c\n");
  controler.manual_robot(VR,VL,continuar,variables);
  printf("3c\n");
  return 0;*/
}


int client(void){
  // The string to send to the server. Done here as a char array so that its
  // easier to figure out its length.
  char *strToSend="Hello Server";
  // The buffer in which to recieve the hello from the server
  char buff[100];
  // The size of the string the server sent
  size_t strSize;
  // The socket object
  ArSocket sock;

  // Initialize Aria. For Windows, this absolutely must be done. Because
  // Windows does not initialize the socket layer for each program. Each
  // program must initialize the sockets itself.
  Aria::init();

  // Lets connect to the server
  if (sock.connect("localhost", 7777, ArSocket::TCP))
    printf("Connected to server\n");
  else
  {
    printf("Failed to connect to server: %s\n", sock.getErrorStr().c_str());
    return(-1);
  }

  // Lets wait for the server to say hello to us.
  strSize=sock.read(buff, sizeof(buff));

  // If the amount read is 0 or less, its an error condition.
  if (strSize > 0)
  {
    // Terminate the string with a NULL character.
    buff[strSize]='\0';
    printf("Server said: %s\n", buff);
  }
  else
  {
    printf("Error in waiting/reading the hello from the server\n");
    return(-1);
  }

  // Lets send the string 'Hello Server' to the server. The write should
  // return the same number of bytes that we told it to write. Otherwise,
  // its an error condition.
  if (sock.write(strToSend, strlen(strToSend)) == strlen(strToSend))
    printf("Said hello to the server\n");
  else
  {
    printf("Error in sending hello string to the server\n");
    return(-1);
  }

  // Now lets close the connection to the server
  //sock.close();
  printf("Socket to server closed\n");

  // Uninitialize Aria
  Aria::uninit();

  // All done
  return(0);
}

int server(void){
  // The string to send to the client. Done here as a char array so that its
  // easier to figure out its length.
  char *strToSend="Hello Client";
  // The buffer in which to recieve the hello from the client
  char buff[100];
  // The size of the string the client sent
  size_t strSize;
  // The socket object
  ArSocket serverSock, clientSock;

  // Initialize Aria. For Windows, this absolutely must be done. Because
  // Windows does not initialize the socket layer for each program. Each
  // program must initialize the sockets itself.
  Aria::init();

  // Lets open the server socket
  if (serverSock.open(7777, ArSocket::TCP))
    printf("Opened the server port\n");
  else
  {
    printf("Failed to open the server port: %s\n",
	   serverSock.getErrorStr().c_str());
    return(-1);
  }

  // Lets wait for the client to connect to us.
  if (serverSock.accept(&clientSock))
    printf("Client has connected\n");
  else
    printf("Error in accepting a connection from the client: %s\n",
	   serverSock.getErrorStr().c_str());

  // Lets send the string 'Hello Client' to the client. The write should
  // return the same number of bytes that we told it to write. Otherwise,
  // its an error condition.
  if (clientSock.write(strToSend, strlen(strToSend)) == strlen(strToSend))
    printf("Said hello to the client\n");
  else
  {
    printf("Error in sending hello string to the client\n");
    return(-1);
  }

  // Lets wait for the client to say hello to us.
  strSize=clientSock.read(buff, sizeof(buff));

  // If the amount read is 0 or less, its an error condition.
  if (strSize > 0)
  {
    // Terminate the string with a NULL character.
    buff[strSize]='\0';
    printf("Client said: %s\n", buff);
  }
  else
  {
    printf("Error in waiting/reading the hello from the client\n");
    return(-1);
  }

  // Now lets close the connection to the client
  clientSock.close();
  printf("Socket to client closed\n");
  // And lets close the server port
  serverSock.close();
  printf("Server socket closed\n");

  //printf("%d\n", clientSock.getFD());

  // Uninitialize Aria
  Aria::uninit();

  // All done
  return(0);
}


int main1(int argc, char **argv){

  char *IP = "127.0.0.1";
  //char *IP = "192.168.1.99";
  int  port= 8101;
  var_robot *variables;
  int modo;
  variables =new var_robot();
  const char *str;
  int ret;  
  ArSerialConnection con_s;
  /*scanf("%d",&modo);
  if (modo==2)
  client();
  else{
  server(); 
  printf("iniciar_robot");
  robot_control controler(IP,port);
  controler.main_robot(variables);}*/
  Aria::init(Aria::SIGHANDLE_THREAD);
  robot_control controler(argv[1]);

  //Aria::init(Aria::SIGHANDLE_THREAD); //printf("5\n");
  controler.robot->runAsync(true);
  
  con_s.setPort(argv[1]);
  //con_s->setPort("com8");
  
    if ((ret = con_s.open()) != 0){
    str = con_s.getOpenMessage(ret);
    printf("Open failed: %s\n", str);
    Aria::shutdown();
    return 1;}

  controler.robot->setDeviceConnection(&con_s);
  
  if (!controler.robot->blockingConnect()){
    printf("asyncConnect failed because robot is not running in its own thread.\n");
  	Aria::shutdown();
    return 1;}
  
  printf("puerto: %s",argv[1]);
  controler.main_robot(variables);
  Aria::shutdown();

	return 0;
}

int main_serial(char *PUERTO, var_robot *variables){

  const char *str;
  int ret;
  //printf("%d\n",argc);
  char *IP = "127.0.0.1";
  //char *IP = "192.168.1.99";
  int  port= 8101;	
  robot_control controler(PUERTO);

  
  printf("0\n");

  ArPose desp; //inicializacion de direcciones
  ArSerialConnection con; 
  ArRobot *robot;
  robot = new ArRobot;
  ConnHandler ch(robot);
  /*var_robot *variables;
  variables =new var_robot();
*/
  // init area with a dedicated signal handling thread
  Aria::init(Aria::SIGHANDLE_THREAD); printf("5\n");
  
 
  if ((ret = con.open(PUERTO)) != 0)

  {
    str = con.getOpenMessage(ret);
    printf("Open failed: %s\n", str);
	//body();
    Aria::shutdown();
    return 1;
  }
  robot->setDeviceConnection(&con);
  if (!robot->blockingConnect())
  {
    printf(
    "asyncConnect failed because robot is not running in its own thread.\n");
    //body();
	Aria::shutdown();
    return 1;
  }

  robot->runAsync(true); 
  controler.robot=robot;
  controler.main_robot(variables);
  Aria::shutdown();
  return 0;
}


/*int main(int argc, char **argv){

main_iniciar_serial(argv[1]);
}*/