// File         : winappstdio.h
// Author       : Brian Boylston
// Purpose      : enables win32 applications to use standard C and C++ io
// Created      : 12/21/1998
// Last Modified: 12/21/1998


#ifndef _WIN_APP_STDIO_H_
#define _WIN_APP_STDIO_H_


// prototypes
//

// initializes C and C++ standard i/o (stdin, stdout, and stderr)
//   for a win32 windowed application
// creates a console window where the i/o will take place
// the title of the console window is set to the string pointed to
//   by pszConsoleTitle if pszConsoleTitle is not NULL. if it is
//   NULL, the console title remains as it is when the console
//   window is created
// an application should call CloseWinAppConsole() when it is done
//   using standard i/o or before the application exits
// returns nonzero on success
// returns zero on failure and error code may be retrieved by
//   calling GetLastError()
int OpenWinAppConsole( const char* pszConsoleTitle = NULL );

// closes the console window and closes all extra file handles
//   created by OpenWinAppConsole()
// returns nonzero on success
// returns zero on failure and error code may be retrieved by
//   calling GetLastError()
extern int CloseWinAppConsole();


#endif  // _WIN_APP_STDIO_H_
